import{S as Nv,i as Dv,s as Sv,e as n,k as p,w as u,t as r,M as Tv,c as a,d as o,m as c,a as s,x as h,h as l,b as i,N as E,f as jv,G as e,g as f,y as g,q as _,o as v,B as b,v as Av,L as hu}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as F}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as A}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as S}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as uu}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Iv($e){let w,N,k,y,P;return y=new A({props:{code:`# !pip install opencv-python transformers accelerate
from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
from diffusers.utils import load_image
import numpy as np
import torch

import cv2
from PIL import Image

# download an image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)
image = np.array(image)

# get canny image
image = cv2.Canny(image, 100, 200)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)

# load control net and stable diffusion v1-5
controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)

# speed up diffusion process with faster scheduler and memory optimization
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
# remove following line if xformers is not installed
pipe.enable_xformers_memory_efficient_attention()

pipe.enable_model_cpu_offload()

# generate image
generator = torch.manual_seed(0)
image = pipe(
    "futuristic-looking woman", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># !pip install opencv-python transformers accelerate</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> cv2
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># download an image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = load_image(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.array(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># get canny image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = cv2.Canny(image, <span class="hljs-number">100</span>, <span class="hljs-number">200</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = image[:, :, <span class="hljs-literal">None</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>canny_image = Image.fromarray(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load control net and stable diffusion v1-5</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionControlNetPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># speed up diffusion process with faster scheduler and memory optimization</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># remove following line if xformers is not installed</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># generate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;futuristic-looking woman&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
<span class="hljs-meta">... </span>).images[<span class="hljs-number">0</span>]`}}),{c(){w=n("p"),N=r("Examples:"),k=p(),u(y.$$.fragment)},l(m){w=a(m,"P",{});var x=s(w);N=l(x,"Examples:"),x.forEach(o),k=c(m),h(y.$$.fragment,m)},m(m,x){f(m,w,x),e(w,N),f(m,k,x),g(y,m,x),P=!0},p:hu,i(m){P||(_(y.$$.fragment,m),P=!0)},o(m){v(y.$$.fragment,m),P=!1},d(m){m&&o(w),m&&o(k),b(y,m)}}}function Mv($e){let w,N,k,y,P;return y=new A({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){w=n("p"),N=r("Examples:"),k=p(),u(y.$$.fragment)},l(m){w=a(m,"P",{});var x=s(w);N=l(x,"Examples:"),x.forEach(o),k=c(m),h(y.$$.fragment,m)},m(m,x){f(m,w,x),e(w,N),f(m,k,x),g(y,m,x),P=!0},p:hu,i(m){P||(_(y.$$.fragment,m),P=!0)},o(m){v(y.$$.fragment,m),P=!1},d(m){m&&o(w),m&&o(k),b(y,m)}}}function qv($e){let w,N,k,y,P;return y=new A({props:{code:`import jax
import numpy as np
import jax.numpy as jnp
from flax.jax_utils import replicate
from flax.training.common_utils import shard
from diffusers.utils import load_image
from PIL import Image
from diffusers import FlaxStableDiffusionControlNetPipeline, FlaxControlNetModel


def image_grid(imgs, rows, cols):
    w, h = imgs[0].size
    grid = Image.new("RGB", size=(cols * w, rows * h))
    for i, img in enumerate(imgs):
        grid.paste(img, box=(i % cols * w, i // cols * h))
    return grid


def create_key(seed=0):
    return jax.random.PRNGKey(seed)


rng = create_key(0)

# get canny image
canny_image = load_image(
    "https://huggingface.co/datasets/YiYiXu/test-doc-assets/resolve/main/blog_post_cell_10_output_0.jpeg"
)

prompts = "best quality, extremely detailed"
negative_prompts = "monochrome, lowres, bad anatomy, worst quality, low quality"

# load control net and stable diffusion v1-5
controlnet, controlnet_params = FlaxControlNetModel.from_pretrained(
    "lllyasviel/sd-controlnet-canny", from_pt=True, dtype=jnp.float32
)
pipe, params = FlaxStableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, revision="flax", dtype=jnp.float32
)
params["controlnet"] = controlnet_params

num_samples = jax.device_count()
rng = jax.random.split(rng, jax.device_count())

prompt_ids = pipe.prepare_text_inputs([prompts] * num_samples)
negative_prompt_ids = pipe.prepare_text_inputs([negative_prompts] * num_samples)
processed_image = pipe.prepare_image_inputs([canny_image] * num_samples)

p_params = replicate(params)
prompt_ids = shard(prompt_ids)
negative_prompt_ids = shard(negative_prompt_ids)
processed_image = shard(processed_image)

output = pipe(
    prompt_ids=prompt_ids,
    image=processed_image,
    params=p_params,
    prng_seed=rng,
    num_inference_steps=50,
    neg_prompt_ids=negative_prompt_ids,
    jit=True,
).images

output_images = pipe.numpy_to_pil(np.asarray(output.reshape((num_samples,) + output.shape[-3:])))
output_images = image_grid(output_images, num_samples // 4, 4)
output_images.save("generated_image.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax.numpy <span class="hljs-keyword">as</span> jnp
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.jax_utils <span class="hljs-keyword">import</span> replicate
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.training.common_utils <span class="hljs-keyword">import</span> shard
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxStableDiffusionControlNetPipeline, FlaxControlNetModel


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">image_grid</span>(<span class="hljs-params">imgs, rows, cols</span>):
<span class="hljs-meta">... </span>    w, h = imgs[<span class="hljs-number">0</span>].size
<span class="hljs-meta">... </span>    grid = Image.new(<span class="hljs-string">&quot;RGB&quot;</span>, size=(cols * w, rows * h))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> i, img <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(imgs):
<span class="hljs-meta">... </span>        grid.paste(img, box=(i % cols * w, i // cols * h))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> grid


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">create_key</span>(<span class="hljs-params">seed=<span class="hljs-number">0</span></span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> jax.random.PRNGKey(seed)


<span class="hljs-meta">&gt;&gt;&gt; </span>rng = create_key(<span class="hljs-number">0</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># get canny image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>canny_image = load_image(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://huggingface.co/datasets/YiYiXu/test-doc-assets/resolve/main/blog_post_cell_10_output_0.jpeg&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompts = <span class="hljs-string">&quot;best quality, extremely detailed&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompts = <span class="hljs-string">&quot;monochrome, lowres, bad anatomy, worst quality, low quality&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load control net and stable diffusion v1-5</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>controlnet, controlnet_params = FlaxControlNetModel.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, from_pt=<span class="hljs-literal">True</span>, dtype=jnp.float32
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe, params = FlaxStableDiffusionControlNetPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, revision=<span class="hljs-string">&quot;flax&quot;</span>, dtype=jnp.float32
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>params[<span class="hljs-string">&quot;controlnet&quot;</span>] = controlnet_params

<span class="hljs-meta">&gt;&gt;&gt; </span>num_samples = jax.device_count()
<span class="hljs-meta">&gt;&gt;&gt; </span>rng = jax.random.split(rng, jax.device_count())

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = pipe.prepare_text_inputs([prompts] * num_samples)
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompt_ids = pipe.prepare_text_inputs([negative_prompts] * num_samples)
<span class="hljs-meta">&gt;&gt;&gt; </span>processed_image = pipe.prepare_image_inputs([canny_image] * num_samples)

<span class="hljs-meta">&gt;&gt;&gt; </span>p_params = replicate(params)
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = shard(prompt_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompt_ids = shard(negative_prompt_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>processed_image = shard(processed_image)

<span class="hljs-meta">&gt;&gt;&gt; </span>output = pipe(
<span class="hljs-meta">... </span>    prompt_ids=prompt_ids,
<span class="hljs-meta">... </span>    image=processed_image,
<span class="hljs-meta">... </span>    params=p_params,
<span class="hljs-meta">... </span>    prng_seed=rng,
<span class="hljs-meta">... </span>    num_inference_steps=<span class="hljs-number">50</span>,
<span class="hljs-meta">... </span>    neg_prompt_ids=negative_prompt_ids,
<span class="hljs-meta">... </span>    jit=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span>output_images = pipe.numpy_to_pil(np.asarray(output.reshape((num_samples,) + output.shape[-<span class="hljs-number">3</span>:])))
<span class="hljs-meta">&gt;&gt;&gt; </span>output_images = image_grid(output_images, num_samples // <span class="hljs-number">4</span>, <span class="hljs-number">4</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>output_images.save(<span class="hljs-string">&quot;generated_image.png&quot;</span>)`}}),{c(){w=n("p"),N=r("Examples:"),k=p(),u(y.$$.fragment)},l(m){w=a(m,"P",{});var x=s(w);N=l(x,"Examples:"),x.forEach(o),k=c(m),h(y.$$.fragment,m)},m(m,x){f(m,w,x),e(w,N),f(m,k,x),g(y,m,x),P=!0},p:hu,i(m){P||(_(y.$$.fragment,m),P=!0)},o(m){v(y.$$.fragment,m),P=!1},d(m){m&&o(w),m&&o(k),b(y,m)}}}function Fv($e){let w,N,k,y,P,m,x,ya,Zl,Ui,ne,Ee,wa,xt,Ql,$a,ep,zi,Ct,Pt,tp,op,Ri,Ko,np,Hi,Yo,ap,Wi,Jo,Ea,sp,Bi,ke,ip,jt,rp,lp,Vi,Xo,pp,Ki,xe,ka,Nt,cp,dp,xa,Dt,fp,Yi,ae,Ce,Ca,St,mp,Pa,up,Ji,Pe,ja,se,Na,hp,gp,Da,_p,vp,Zo,bp,yp,Sa,ie,Ta,Tt,wp,$p,Aa,Ia,Ep,kp,Qo,At,xp,Xi,re,je,Ma,It,Cp,qa,Pp,Zi,Ne,jp,Fa,Np,Dp,Qi,De,La,Ga,Oa,Sp,Tp,Ua,en,Mt,Ap,tn,Ip,Mp,er,Se,qp,qt,Fp,Lp,tr,Ft,or,on,nn,gu,nr,V,Gp,za,Op,Up,an,zp,Rp,ar,sn,Hp,sr,Lt,ir,rn,Wp,rr,Gt,lr,ln,Bp,pr,Ot,cr,pn,Vp,dr,cn,dn,_u,fr,Te,Kp,fn,Yp,Jp,mr,Ut,ur,Ae,Xp,mn,Zp,Qp,hr,zt,gr,un,ec,_r,Rt,vr,hn,tc,br,gn,_n,vu,yr,le,Ra,oc,nc,vn,ac,sc,wr,pe,Ie,Ha,Ht,ic,Wa,rc,$r,Me,lc,Ba,pc,cc,Er,bn,dc,kr,qe,fc,Va,mc,uc,xr,ce,Fe,Ka,Wt,hc,Ya,gc,Cr,yn,_c,Pr,wn,bu,jr,$n,vc,Nr,Bt,Dr,En,yu,Sr,de,Le,Ja,Vt,bc,Xa,yc,Tr,kn,wc,Ar,Kt,wu,Ir,xn,$c,Mr,Yt,qr,Jt,$u,Fr,fe,Ge,Za,Xt,Ec,Qa,kc,Lr,Zt,Gr,Qt,Eu,Or,me,Oe,es,eo,xc,ts,Cc,Ur,K,Pc,to,jc,Nc,oo,Dc,Sc,zr,Cn,os,Tc,Rr,ue,Ue,ns,no,Ac,as,Ic,Hr,Y,Mc,ss,qc,Fc,is,Lc,Gc,Wr,ze,Oc,rs,Uc,zc,Br,he,Re,ls,ao,Rc,ps,Hc,Vr,q,Wc,cs,Bc,Vc,ds,Kc,Yc,so,Jc,Xc,Kr,io,Yr,ge,He,fs,ro,Zc,ms,Qc,Jr,We,us,lo,hs,ed,td,gs,od,nd,_s,po,vs,Pn,jn,ku,ad,bs,Nn,Dn,xu,Xr,_e,Be,ys,co,sd,ws,id,Zr,J,rd,$s,ld,pd,Es,cd,dd,Qr,Ve,fd,fo,md,ud,el,ve,Ke,ks,mo,hd,xs,gd,tl,Ye,Cs,L,Ps,_d,vd,js,bd,yd,Ns,wd,$d,Ds,Ed,kd,j,G,Je,uo,xd,Cd,Pd,Ss,jd,Nd,Ts,Dd,Sd,As,Sn,Xe,Cu,Td,Is,Tn,An,Pu,Ad,O,Ze,ho,Id,Md,qd,Ms,Fd,Ld,qs,Gd,Od,Fs,In,Mn,ju,Ud,Ls,qn,Fn,Nu,zd,U,Qe,go,Rd,Hd,Wd,Gs,Bd,Vd,Os,Kd,Yd,Us,Ln,Gn,Du,Jd,zs,On,Un,Su,Xd,z,et,_o,Zd,Qd,ef,Rs,tf,of,Hs,nf,af,Ws,zn,Rn,Tu,sf,Bs,Hn,Wn,Au,rf,R,tt,vo,lf,pf,cf,Vs,df,ff,bo,mf,yo,uf,hf,gf,Ks,Bn,Vn,Iu,_f,Ys,Kn,Yn,Mu,vf,H,ot,wo,bf,yf,wf,Js,$f,Ef,$o,kf,Eo,xf,Cf,Pf,Xs,Jn,Xn,qu,jf,Zs,Zn,Qn,Fu,Nf,W,nt,ko,Df,Sf,Tf,Qs,Af,If,ei,Mf,qf,ti,ea,ta,Lu,Ff,oi,oa,na,Gu,Lf,B,xo,Co,Gf,Of,ni,Uf,zf,Po,Rf,jo,Hf,Wf,Bf,ai,aa,sa,Ou,Vf,si,ia,ra,Uu,ol,be,at,ii,No,Kf,ri,Yf,nl,$,Do,Jf,li,Xf,Zf,So,Qf,la,em,tm,om,X,To,nm,pi,am,sm,st,im,Z,Ao,rm,ci,lm,pm,di,cm,dm,it,Io,fm,Mo,mm,fi,um,hm,gm,Q,qo,_m,mi,vm,bm,ui,ym,wm,rt,Fo,$m,Lo,Em,hi,km,xm,Cm,T,Go,Pm,gi,jm,Nm,_i,Dm,Sm,vi,Tm,Am,lt,Im,pt,Oo,Mm,bi,qm,Fm,ct,Uo,Lm,I,Gm,yi,Om,Um,wi,zm,Rm,$i,Hm,Wm,Ei,Bm,Vm,Km,dt,zo,Ym,ye,Jm,ki,Xm,Zm,xi,Qm,eu,al,we,ft,Ci,Ro,tu,Pi,ou,sl,M,Ho,nu,ji,au,su,Wo,iu,Ni,ru,lu,pu,ee,Bo,cu,Di,du,fu,mt,il;return m=new S({}),xt=new S({}),St=new S({}),It=new S({}),Ft=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline
from diffusers.utils import load_image

# Let's load the popular vermeer image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

<span class="hljs-comment"># Let&#x27;s load the popular vermeer image</span>
image = load_image(
    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
)`}}),Lt=new A({props:{code:"pip install opencv-contrib-python",highlighted:'pip <span class="hljs-keyword">install</span> opencv-contrib-python'}}),Gt=new A({props:{code:"pip install diffusers transformers git+https://github.com/huggingface/accelerate.git",highlighted:'pip install diffusers transformers git+https:<span class="hljs-regexp">//gi</span>thub.com<span class="hljs-regexp">/huggingface/</span>accelerate.git'}}),Ot=new A({props:{code:`import cv2
from PIL import Image
import numpy as np

image = np.array(image)

low_threshold = 100
high_threshold = 200

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)`,highlighted:`<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

image = np.array(image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, <span class="hljs-literal">None</span>]
image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(image)`}}),Ut=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel
import torch

controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel
<span class="hljs-keyword">import</span> torch

controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)`}}),zt=new A({props:{code:`from diffusers import UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

# this command loads the individual model components on GPU on-demand.
pipe.enable_model_cpu_offload()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

<span class="hljs-comment"># this command loads the individual model components on GPU on-demand.</span>
pipe.enable_model_cpu_offload()`}}),Rt=new A({props:{code:`generator = torch.manual_seed(0)

out_image = pipe(
    "disco dancer with colorful lights", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`generator = torch.manual_seed(<span class="hljs-number">0</span>)

out_image = pipe(
    <span class="hljs-string">&quot;disco dancer with colorful lights&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
).images[<span class="hljs-number">0</span>]`}}),Ht=new S({}),Wt=new S({}),Bt=new A({props:{code:`from diffusers.utils import load_image
from PIL import Image
import cv2
import numpy as np
from diffusers.utils import load_image

canny_image = load_image(
    "https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png"
)
canny_image = np.array(canny_image)

low_threshold = 100
high_threshold = 200

canny_image = cv2.Canny(canny_image, low_threshold, high_threshold)

# zero out middle columns of image where pose will be overlayed
zero_start = canny_image.shape[1] // 4
zero_end = zero_start + canny_image.shape[1] // 2
canny_image[:, zero_start:zero_end] = 0

canny_image = canny_image[:, :, None]
canny_image = np.concatenate([canny_image, canny_image, canny_image], axis=2)
canny_image = Image.fromarray(canny_image)`,highlighted:`<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

canny_image = load_image(
    <span class="hljs-string">&quot;https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png&quot;</span>
)
canny_image = np.array(canny_image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

canny_image = cv2.Canny(canny_image, low_threshold, high_threshold)

<span class="hljs-comment"># zero out middle columns of image where pose will be overlayed</span>
zero_start = canny_image.shape[<span class="hljs-number">1</span>] // <span class="hljs-number">4</span>
zero_end = zero_start + canny_image.shape[<span class="hljs-number">1</span>] // <span class="hljs-number">2</span>
canny_image[:, zero_start:zero_end] = <span class="hljs-number">0</span>

canny_image = canny_image[:, :, <span class="hljs-literal">None</span>]
canny_image = np.concatenate([canny_image, canny_image, canny_image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(canny_image)`}}),Vt=new S({}),Yt=new A({props:{code:`from controlnet_aux import OpenposeDetector
from diffusers.utils import load_image

openpose = OpenposeDetector.from_pretrained("lllyasviel/ControlNet")

openpose_image = load_image(
    "https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png"
)
openpose_image = openpose(openpose_image)`,highlighted:`<span class="hljs-keyword">from</span> controlnet_aux <span class="hljs-keyword">import</span> OpenposeDetector
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

openpose = OpenposeDetector.from_pretrained(<span class="hljs-string">&quot;lllyasviel/ControlNet&quot;</span>)

openpose_image = load_image(
    <span class="hljs-string">&quot;https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png&quot;</span>
)
openpose_image = openpose(openpose_image)`}}),Xt=new S({}),Zt=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
import torch

controlnet = [
    ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-openpose", torch_dtype=torch.float16),
    ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16),
]

pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

pipe.enable_xformers_memory_efficient_attention()
pipe.enable_model_cpu_offload()

prompt = "a giant standing in a fantasy landscape, best quality"
negative_prompt = "monochrome, lowres, bad anatomy, worst quality, low quality"

generator = torch.Generator(device="cpu").manual_seed(1)

images = [openpose_image, canny_image]

image = pipe(
    prompt,
    images,
    num_inference_steps=20,
    generator=generator,
    negative_prompt=negative_prompt,
    controlnet_conditioning_scale=[1.0, 0.8],
).images[0]

image.save("./multi_controlnet_output.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-keyword">import</span> torch

controlnet = [
    ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-openpose&quot;</span>, torch_dtype=torch.float16),
    ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16),
]

pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

pipe.enable_xformers_memory_efficient_attention()
pipe.enable_model_cpu_offload()

prompt = <span class="hljs-string">&quot;a giant standing in a fantasy landscape, best quality&quot;</span>
negative_prompt = <span class="hljs-string">&quot;monochrome, lowres, bad anatomy, worst quality, low quality&quot;</span>

generator = torch.Generator(device=<span class="hljs-string">&quot;cpu&quot;</span>).manual_seed(<span class="hljs-number">1</span>)

images = [openpose_image, canny_image]

image = pipe(
    prompt,
    images,
    num_inference_steps=<span class="hljs-number">20</span>,
    generator=generator,
    negative_prompt=negative_prompt,
    controlnet_conditioning_scale=[<span class="hljs-number">1.0</span>, <span class="hljs-number">0.8</span>],
).images[<span class="hljs-number">0</span>]

image.save(<span class="hljs-string">&quot;./multi_controlnet_output.png&quot;</span>)`}}),eo=new S({}),no=new S({}),ao=new S({}),io=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel
import torch

controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny")
pipe = StableDiffusionControlNetPipeline.from_pretrained("runwayml/stable-diffusion-v1-5", controlnet=controlnet).to(
    "cuda"
)
image = pipe("", image=canny_image, guess_mode=True, guidance_scale=3.0).images[0]
image.save("guess_mode_generated.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel
<span class="hljs-keyword">import</span> torch

controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>)
pipe = StableDiffusionControlNetPipeline.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet).to(
    <span class="hljs-string">&quot;cuda&quot;</span>
)
image = pipe(<span class="hljs-string">&quot;&quot;</span>, image=canny_image, guess_mode=<span class="hljs-literal">True</span>, guidance_scale=<span class="hljs-number">3.0</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;guess_mode_generated.png&quot;</span>)`}}),ro=new S({}),co=new S({}),mo=new S({}),No=new S({}),Do=new F({props:{name:"class diffusers.StableDiffusionControlNetPipeline",anchor:"diffusers.StableDiffusionControlNetPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"controlnet",val:": typing.Union[diffusers.models.controlnet.ControlNetModel, typing.List[diffusers.models.controlnet.ControlNetModel], typing.Tuple[diffusers.models.controlnet.ControlNetModel], diffusers.pipelines.stable_diffusion.pipeline_stable_diffusion_controlnet.MultiControlNetModel]"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPImageProcessor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_3122/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionControlNetPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionControlNetPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionControlNetPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_3122/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.controlnet",description:`<strong>controlnet</strong> (<a href="/docs/diffusers/pr_3122/en/api/models#diffusers.ControlNetModel">ControlNetModel</a> or <code>List[ControlNetModel]</code>) &#x2014;
Provides additional conditioning to the unet during the denoising process. If you set multiple ControlNets
as a list, the outputs from each ControlNet are added together to create one combined additional
conditioning.`,name:"controlnet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_3122/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/pr_3122/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/pr_3122/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/pr_3122/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionControlNetPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionControlNetPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPImageProcessor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L152"}}),To=new F({props:{name:"__call__",anchor:"diffusers.StableDiffusionControlNetPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image, typing.List[torch.FloatTensor], typing.List[PIL.Image.Image]] = None"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"controlnet_conditioning_scale",val:": typing.Union[float, typing.List[float]] = 1.0"},{name:"guess_mode",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code>, <code>PIL.Image.Image</code>, <code>List[torch.FloatTensor]</code>, <code>List[PIL.Image.Image]</code>, &#x2014;
<code>List[List[torch.FloatTensor]]</code>, or <code>List[List[PIL.Image.Image]]</code>):
The ControlNet input condition. ControlNet uses this input condition to generate guidance to Unet. If
the type is specified as <code>Torch.FloatTensor</code>, it is passed to ControlNet as is. <code>PIL.Image.Image</code> can
also be accepted as an image. The dimensions of the output image defaults to <code>image</code>&#x2019;s dimensions. If
height and/or width are passed, <code>image</code> is resized according to them. If multiple ControlNets are
specified in init, images must be passed as a list such that each element of the list can be correctly
batched for input to a single controlnet.`,name:"image"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code> instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is
less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_3122/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_3122/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.controlnet_conditioning_scale",description:`<strong>controlnet_conditioning_scale</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The outputs of the controlnet are multiplied by <code>controlnet_conditioning_scale</code> before they are added
to the residual in the original unet. If multiple ControlNets are specified in init, you can set the
corresponding scale as a list.`,name:"controlnet_conditioning_scale"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.guess_mode",description:`<strong>guess_mode</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
In this mode, the ControlNet encoder will try best to recognize the content of the input image even if
you remove all prompts. The <code>guidance_scale</code> between 3.0 and 5.0 is recommended.`,name:"guess_mode"}],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L738",returnDescription:`
<p><a
  href="/docs/diffusers/pr_3122/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_3122/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),st=new uu({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.example",$$slots:{default:[Iv]},$$scope:{ctx:$e}}}),Ao=new F({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/pipeline_utils.py#L1462"}}),Io=new F({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/pipeline_utils.py#L1478"}}),qo=new F({props:{name:"enable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L232"}}),Fo=new F({props:{name:"disable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L242"}}),Go=new F({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/pipeline_utils.py#L1403"}}),lt=new uu({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[Mv]},$$scope:{ctx:$e}}}),Oo=new F({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/pipeline_utils.py#L1435"}}),Uo=new F({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L270"}}),zo=new F({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L249"}}),Ro=new S({}),Ho=new F({props:{name:"class diffusers.FlaxStableDiffusionControlNetPipeline",anchor:"diffusers.FlaxStableDiffusionControlNetPipeline",parameters:[{name:"vae",val:": FlaxAutoencoderKL"},{name:"text_encoder",val:": FlaxCLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": FlaxUNet2DConditionModel"},{name:"controlnet",val:": FlaxControlNetModel"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim_flax.FlaxDDIMScheduler, diffusers.schedulers.scheduling_pndm_flax.FlaxPNDMScheduler, diffusers.schedulers.scheduling_lms_discrete_flax.FlaxLMSDiscreteScheduler, diffusers.schedulers.scheduling_dpmsolver_multistep_flax.FlaxDPMSolverMultistepScheduler]"},{name:"safety_checker",val:": FlaxStableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_3122/en/api/models#diffusers.FlaxAutoencoderKL">FlaxAutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>FlaxCLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.FlaxCLIPTextModel" rel="nofollow">CLIP</a>,
specifically the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_3122/en/api/models#diffusers.FlaxUNet2DConditionModel">FlaxUNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.controlnet",description:`<strong>controlnet</strong> (<a href="/docs/diffusers/pr_3122/en/api/models#diffusers.FlaxControlNetModel">FlaxControlNetModel</a> &#x2014;
Provides additional conditioning to the unet during the denoising process.`,name:"controlnet"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_3122/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<code>FlaxDDIMScheduler</code>, <code>FlaxLMSDiscreteScheduler</code>, <code>FlaxPNDMScheduler</code>, or
<code>FlaxDPMSolverMultistepScheduler</code>.`,name:"scheduler"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>FlaxStableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_controlnet.py#L119"}}),Bo=new F({props:{name:"__call__",anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__",parameters:[{name:"prompt_ids",val:": array"},{name:"image",val:": array"},{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"prng_seed",val:": PRNGKeyArray"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": typing.Union[float, array] = 7.5"},{name:"latents",val:": array = None"},{name:"neg_prompt_ids",val:": array = None"},{name:"controlnet_conditioning_scale",val:": typing.Union[float, array] = 1.0"},{name:"return_dict",val:": bool = True"},{name:"jit",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.prompt_ids",description:`<strong>prompt_ids</strong> (<code>jnp.array</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt_ids"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.image",description:`<strong>image</strong> (<code>jnp.array</code>) &#x2014;
Array representing the ControlNet input condition. ControlNet use this input condition to generate
guidance to Unet.`,name:"image"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.params",description:"<strong>params</strong> (<code>Dict</code> or <code>FrozenDict</code>) &#x2014; Dictionary containing the model parameters/weights",name:"params"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.prng_seed",description:"<strong>prng_seed</strong> (<code>jax.random.KeyArray</code> or <code>jax.Array</code>) &#x2014; Array containing random number generator key",name:"prng_seed"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.latents",description:`<strong>latents</strong> (<code>jnp.array</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.controlnet_conditioning_scale",description:`<strong>controlnet_conditioning_scale</strong> (<code>float</code> or <code>jnp.array</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The outputs of the controlnet are multiplied by <code>controlnet_conditioning_scale</code> before they are added
to the residual in the original unet.`,name:"controlnet_conditioning_scale"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>FlaxStableDiffusionPipelineOutput</code> instead of
a plain tuple.`,name:"return_dict"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.jit",description:`<strong>jit</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to run <code>pmap</code> versions of the generation and safety scoring functions. NOTE: This argument
exists because <code>__call__</code> is not yet end-to-end pmap-able. It will be removed in a future release.`,name:"jit"}],source:"https://github.com/huggingface/diffusers/blob/vr_3122/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_controlnet.py#L357",returnDescription:`
<p><code>FlaxStableDiffusionPipelineOutput</code> if <code>return_dict</code> is True, otherwise a
<code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>FlaxStableDiffusionPipelineOutput</code> or <code>tuple</code></p>
`}}),mt=new uu({props:{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.example",$$slots:{default:[qv]},$$scope:{ctx:$e}}}),{c(){w=n("meta"),N=p(),k=n("h1"),y=n("a"),P=n("span"),u(m.$$.fragment),x=p(),ya=n("span"),Zl=r("Text-to-Image Generation with ControlNet Conditioning"),Ui=p(),ne=n("h2"),Ee=n("a"),wa=n("span"),u(xt.$$.fragment),Ql=p(),$a=n("span"),ep=r("Overview"),zi=p(),Ct=n("p"),Pt=n("a"),tp=r("Adding Conditional Control to Text-to-Image Diffusion Models"),op=r(" by Lvmin Zhang and Maneesh Agrawala."),Ri=p(),Ko=n("p"),np=r("Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),Hi=p(),Yo=n("p"),ap=r("The abstract of the paper is the following:"),Wi=p(),Jo=n("p"),Ea=n("em"),sp=r("We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),Bi=p(),ke=n("p"),ip=r("This model was contributed by the amazing community contributor "),jt=n("a"),rp=r("takuma104"),lp=r(" \u2764\uFE0F ."),Vi=p(),Xo=n("p"),pp=r("Resources:"),Ki=p(),xe=n("ul"),ka=n("li"),Nt=n("a"),cp=r("Paper"),dp=p(),xa=n("li"),Dt=n("a"),fp=r("Original Code"),Yi=p(),ae=n("h2"),Ce=n("a"),Ca=n("span"),u(St.$$.fragment),mp=p(),Pa=n("span"),up=r("Available Pipelines:"),Ji=p(),Pe=n("table"),ja=n("thead"),se=n("tr"),Na=n("th"),hp=r("Pipeline"),gp=p(),Da=n("th"),_p=r("Tasks"),vp=p(),Zo=n("th"),bp=r("Demo"),yp=p(),Sa=n("tbody"),ie=n("tr"),Ta=n("td"),Tt=n("a"),wp=r("StableDiffusionControlNetPipeline"),$p=p(),Aa=n("td"),Ia=n("em"),Ep=r("Text-to-Image Generation with ControlNet Conditioning"),kp=p(),Qo=n("td"),At=n("a"),xp=r("Colab Example"),Xi=p(),re=n("h2"),je=n("a"),Ma=n("span"),u(It.$$.fragment),Cp=p(),qa=n("span"),Pp=r("Usage example"),Zi=p(),Ne=n("p"),jp=r("In the following we give a simple example of how to use a "),Fa=n("em"),Np=r("ControlNet"),Dp=r(` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),Qi=p(),De=n("ul"),La=n("li"),Ga=n("ol"),Oa=n("li"),Sp=r("Take an image and run it through a pre-conditioning processor."),Tp=p(),Ua=n("li"),en=n("ol"),Mt=n("li"),Ap=r("Run the pre-processed image through the "),tn=n("a"),Ip=r("StableDiffusionControlNetPipeline"),Mp=r("."),er=p(),Se=n("p"),qp=r("Let\u2019s have a look at a simple example using the "),qt=n("a"),Fp=r("Canny Edge ControlNet"),Lp=r("."),tr=p(),u(Ft.$$.fragment),or=p(),on=n("p"),nn=n("img"),nr=p(),V=n("p"),Gp=r("Next, we process the image to get the canny image. This is step "),za=n("em"),Op=r("1."),Up=r(" - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),an=n("a"),zp=r("official checkpoints"),Rp=r(" for more information about other models."),ar=p(),sn=n("p"),Hp=r("First, we need to install opencv:"),sr=p(),u(Lt.$$.fragment),ir=p(),rn=n("p"),Wp=r("Next, let\u2019s also install all required Hugging Face libraries:"),rr=p(),u(Gt.$$.fragment),lr=p(),ln=n("p"),Bp=r("Then we can retrieve the canny edges of the image."),pr=p(),u(Ot.$$.fragment),cr=p(),pn=n("p"),Vp=r("Let\u2019s take a look at the processed image."),dr=p(),cn=n("p"),dn=n("img"),fr=p(),Te=n("p"),Kp=r("Now, we load the official "),fn=n("a"),Yp=r("Stable Diffusion 1.5 Model"),Jp=r(" as well as the ControlNet for canny edges."),mr=p(),u(Ut.$$.fragment),ur=p(),Ae=n("p"),Xp=r("To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),mn=n("a"),Zp=r("UniPCMultistepScheduler"),Qp=r("."),hr=p(),u(zt.$$.fragment),gr=p(),un=n("p"),ec=r("Finally, we can run the pipeline:"),_r=p(),u(Rt.$$.fragment),vr=p(),hn=n("p"),tc=r("This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),br=p(),gn=n("p"),_n=n("img"),yr=p(),le=n("p"),Ra=n("strong"),oc=r("Note"),nc=r(": To see how to run all other ControlNet checkpoints, please have a look at "),vn=n("a"),ac=r("ControlNet with Stable Diffusion 1.5"),sc=r("."),wr=p(),pe=n("h2"),Ie=n("a"),Ha=n("span"),u(Ht.$$.fragment),ic=p(),Wa=n("span"),rc=r("Combining multiple conditionings"),$r=p(),Me=n("p"),lc=r("Multiple ControlNet conditionings can be combined for a single image generation. Pass a list of ControlNets to the pipeline\u2019s constructor and a corresponding list of conditionings to "),Ba=n("code"),pc=r("__call__"),cc=r("."),Er=p(),bn=n("p"),dc=r("When combining conditionings, it is helpful to mask conditionings such that they do not overlap. In the example, we mask the middle of the canny map where the pose conditioning is located."),kr=p(),qe=n("p"),fc=r("It can also be helpful to vary the "),Va=n("code"),mc=r("controlnet_conditioning_scales"),uc=r(" to emphasize one conditioning over the other."),xr=p(),ce=n("h3"),Fe=n("a"),Ka=n("span"),u(Wt.$$.fragment),hc=p(),Ya=n("span"),gc=r("Canny conditioning"),Cr=p(),yn=n("p"),_c=r("The original image:"),Pr=p(),wn=n("img"),jr=p(),$n=n("p"),vc=r("Prepare the conditioning:"),Nr=p(),u(Bt.$$.fragment),Dr=p(),En=n("img"),Sr=p(),de=n("h3"),Le=n("a"),Ja=n("span"),u(Vt.$$.fragment),bc=p(),Xa=n("span"),yc=r("Openpose conditioning"),Tr=p(),kn=n("p"),wc=r("The original image:"),Ar=p(),Kt=n("img"),Ir=p(),xn=n("p"),$c=r("Prepare the conditioning:"),Mr=p(),u(Yt.$$.fragment),qr=p(),Jt=n("img"),Fr=p(),fe=n("h3"),Ge=n("a"),Za=n("span"),u(Xt.$$.fragment),Ec=p(),Qa=n("span"),kc=r("Running ControlNet with multiple conditionings"),Lr=p(),u(Zt.$$.fragment),Gr=p(),Qt=n("img"),Or=p(),me=n("h3"),Oe=n("a"),es=n("span"),u(eo.$$.fragment),xc=p(),ts=n("span"),Cc=r("Guess Mode"),Ur=p(),K=n("p"),Pc=r("Guess Mode is "),to=n("a"),jc=r("a ControlNet feature that was implemented"),Nc=r(" after the publication of "),oo=n("a"),Dc=r("the paper"),Sc=r(". The description states:"),zr=p(),Cn=n("blockquote"),os=n("p"),Tc=r("In this mode, the ControlNet encoder will try best to recognize the content of the input control map, like depth map, edge map, scribbles, etc, even if you remove all prompts."),Rr=p(),ue=n("h4"),Ue=n("a"),ns=n("span"),u(no.$$.fragment),Ac=p(),as=n("span"),Ic=r("The core implementation:"),Hr=p(),Y=n("p"),Mc=r("It adjusts the scale of the output residuals from ControlNet by a fixed ratio depending on the block depth. The shallowest DownBlock corresponds to "),ss=n("code"),qc=r("0.1"),Fc=r(". As the blocks get deeper, the scale increases exponentially, and the scale for the output of the MidBlock becomes "),is=n("code"),Lc=r("1.0"),Gc=r("."),Wr=p(),ze=n("p"),Oc=r("Since the core implementation is just this, "),rs=n("strong"),Uc=r("it does not have any impact on prompt conditioning"),zc=r(". While it is common to use it without specifying any prompts, it is also possible to provide prompts if desired."),Br=p(),he=n("h4"),Re=n("a"),ls=n("span"),u(ao.$$.fragment),Rc=p(),ps=n("span"),Hc=r("Usage:"),Vr=p(),q=n("p"),Wc=r("Just specify "),cs=n("code"),Bc=r("guess_mode=True"),Vc=r(" in the pipe() function. A "),ds=n("code"),Kc=r("guidance_scale"),Yc=r(" between 3.0 and 5.0 is "),so=n("a"),Jc=r("recommended"),Xc=r("."),Kr=p(),u(io.$$.fragment),Yr=p(),ge=n("h4"),He=n("a"),fs=n("span"),u(ro.$$.fragment),Zc=p(),ms=n("span"),Qc=r("Output image comparison:"),Jr=r(`

Canny Control Example
`),We=n("table"),us=n("thead"),lo=n("tr"),hs=n("th"),ed=r("no guess_mode with prompt"),td=p(),gs=n("th"),od=r("guess_mode without prompt"),nd=p(),_s=n("tbody"),po=n("tr"),vs=n("td"),Pn=n("a"),jn=n("img"),ad=p(),bs=n("td"),Nn=n("a"),Dn=n("img"),Xr=p(),_e=n("h2"),Be=n("a"),ys=n("span"),u(co.$$.fragment),sd=p(),ws=n("span"),id=r("Available checkpoints"),Zr=p(),J=n("p"),rd=r("ControlNet requires a "),$s=n("em"),ld=r("control image"),pd=r(" in addition to the text-to-image "),Es=n("em"),cd=r("prompt"),dd=r(`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),Qr=p(),Ve=n("p"),fd=r("All checkpoints can be found under the authors\u2019 namespace "),fo=n("a"),md=r("lllyasviel"),ud=r("."),el=p(),ve=n("h3"),Ke=n("a"),ks=n("span"),u(mo.$$.fragment),hd=p(),xs=n("span"),gd=r("ControlNet with Stable Diffusion 1.5"),tl=p(),Ye=n("table"),Cs=n("thead"),L=n("tr"),Ps=n("th"),_d=r("Model Name"),vd=p(),js=n("th"),bd=r("Control Image Overview"),yd=p(),Ns=n("th"),wd=r("Control Image Example"),$d=p(),Ds=n("th"),Ed=r("Generated Image Example"),kd=p(),j=n("tbody"),G=n("tr"),Je=n("td"),uo=n("a"),xd=r("lllyasviel/sd-controlnet-canny"),Cd=n("br"),Pd=p(),Ss=n("em"),jd=r("Trained with canny edge detection"),Nd=p(),Ts=n("td"),Dd=r("A monochrome image with white edges on a black background."),Sd=p(),As=n("td"),Sn=n("a"),Xe=n("img"),Td=p(),Is=n("td"),Tn=n("a"),An=n("img"),Ad=p(),O=n("tr"),Ze=n("td"),ho=n("a"),Id=r("lllyasviel/sd-controlnet-depth"),Md=n("br"),qd=p(),Ms=n("em"),Fd=r("Trained with Midas depth estimation"),Ld=p(),qs=n("td"),Gd=r("A grayscale image with black representing deep areas and white representing shallow areas."),Od=p(),Fs=n("td"),In=n("a"),Mn=n("img"),Ud=p(),Ls=n("td"),qn=n("a"),Fn=n("img"),zd=p(),U=n("tr"),Qe=n("td"),go=n("a"),Rd=r("lllyasviel/sd-controlnet-hed"),Hd=n("br"),Wd=p(),Gs=n("em"),Bd=r("Trained with HED edge detection (soft edge)"),Vd=p(),Os=n("td"),Kd=r("A monochrome image with white soft edges on a black background."),Yd=p(),Us=n("td"),Ln=n("a"),Gn=n("img"),Jd=p(),zs=n("td"),On=n("a"),Un=n("img"),Xd=p(),z=n("tr"),et=n("td"),_o=n("a"),Zd=r("lllyasviel/sd-controlnet-mlsd"),Qd=n("br"),ef=p(),Rs=n("em"),tf=r("Trained with M-LSD line detection"),of=p(),Hs=n("td"),nf=r("A monochrome image composed only of white straight lines on a black background."),af=p(),Ws=n("td"),zn=n("a"),Rn=n("img"),sf=p(),Bs=n("td"),Hn=n("a"),Wn=n("img"),rf=p(),R=n("tr"),tt=n("td"),vo=n("a"),lf=r("lllyasviel/sd-controlnet-normal"),pf=n("br"),cf=p(),Vs=n("em"),df=r("Trained with normal map"),ff=p(),bo=n("td"),mf=r("A "),yo=n("a"),uf=r("normal mapped"),hf=r(" image."),gf=p(),Ks=n("td"),Bn=n("a"),Vn=n("img"),_f=p(),Ys=n("td"),Kn=n("a"),Yn=n("img"),vf=p(),H=n("tr"),ot=n("td"),wo=n("a"),bf=r("lllyasviel/sd-controlnet-openpose"),yf=n("br"),wf=p(),Js=n("em"),$f=r("Trained with OpenPose bone image"),Ef=p(),$o=n("td"),kf=r("A "),Eo=n("a"),xf=r("OpenPose bone"),Cf=r(" image."),Pf=p(),Xs=n("td"),Jn=n("a"),Xn=n("img"),jf=p(),Zs=n("td"),Zn=n("a"),Qn=n("img"),Nf=p(),W=n("tr"),nt=n("td"),ko=n("a"),Df=r("lllyasviel/sd-controlnet-scribble"),Sf=n("br"),Tf=p(),Qs=n("em"),Af=r("Trained with human scribbles"),If=p(),ei=n("td"),Mf=r("A hand-drawn monochrome image with white outlines on a black background."),qf=p(),ti=n("td"),ea=n("a"),ta=n("img"),Ff=p(),oi=n("td"),oa=n("a"),na=n("img"),Lf=p(),B=n("tr"),xo=n("td"),Co=n("a"),Gf=r("lllyasviel/sd-controlnet-seg"),Of=n("br"),ni=n("em"),Uf=r("Trained with semantic segmentation"),zf=p(),Po=n("td"),Rf=r("An "),jo=n("a"),Hf=r("ADE20K"),Wf=r("\u2019s segmentation protocol image."),Bf=p(),ai=n("td"),aa=n("a"),sa=n("img"),Vf=p(),si=n("td"),ia=n("a"),ra=n("img"),ol=p(),be=n("h2"),at=n("a"),ii=n("span"),u(No.$$.fragment),Kf=p(),ri=n("span"),Yf=r("StableDiffusionControlNetPipeline"),nl=p(),$=n("div"),u(Do.$$.fragment),Jf=p(),li=n("p"),Xf=r("Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),Zf=p(),So=n("p"),Qf=r("This model inherits from "),la=n("a"),em=r("DiffusionPipeline"),tm=r(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),om=p(),X=n("div"),u(To.$$.fragment),nm=p(),pi=n("p"),am=r("Function invoked when calling the pipeline for generation."),sm=p(),u(st.$$.fragment),im=p(),Z=n("div"),u(Ao.$$.fragment),rm=p(),ci=n("p"),lm=r("Enable sliced attention computation."),pm=p(),di=n("p"),cm=r(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),dm=p(),it=n("div"),u(Io.$$.fragment),fm=p(),Mo=n("p"),mm=r("Disable sliced attention computation. If "),fi=n("code"),um=r("enable_attention_slicing"),hm=r(` was previously invoked, this method will go
back to computing attention in one step.`),gm=p(),Q=n("div"),u(qo.$$.fragment),_m=p(),mi=n("p"),vm=r("Enable sliced VAE decoding."),bm=p(),ui=n("p"),ym=r(`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),wm=p(),rt=n("div"),u(Fo.$$.fragment),$m=p(),Lo=n("p"),Em=r("Disable sliced VAE decoding. If "),hi=n("code"),km=r("enable_vae_slicing"),xm=r(` was previously invoked, this method will go back to
computing decoding in one step.`),Cm=p(),T=n("div"),u(Go.$$.fragment),Pm=p(),gi=n("p"),jm=r("Enable memory efficient attention as implemented in xformers."),Nm=p(),_i=n("p"),Dm=r(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Sm=p(),vi=n("p"),Tm=r(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Am=p(),u(lt.$$.fragment),Im=p(),pt=n("div"),u(Oo.$$.fragment),Mm=p(),bi=n("p"),qm=r("Disable memory efficient attention as implemented in xformers."),Fm=p(),ct=n("div"),u(Uo.$$.fragment),Lm=p(),I=n("p"),Gm=r(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),yi=n("code"),Om=r("enable_sequential_cpu_offload"),Um=r(", this method moves one whole model at a time to the GPU when its "),wi=n("code"),zm=r("forward"),Rm=r(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),$i=n("code"),Hm=r("enable_sequential_cpu_offload"),Wm=r(", but performance is much better due to the iterative execution of the "),Ei=n("code"),Bm=r("unet"),Vm=r("."),Km=p(),dt=n("div"),u(zo.$$.fragment),Ym=p(),ye=n("p"),Jm=r(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),ki=n("code"),Xm=r("torch.device('meta') and loaded to GPU only when their specific submodule has its "),Zm=r("forward"),xi=n("code"),Qm=r("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),eu=r("enable_model_cpu_offload`, but performance is lower."),al=p(),we=n("h2"),ft=n("a"),Ci=n("span"),u(Ro.$$.fragment),tu=p(),Pi=n("span"),ou=r("FlaxStableDiffusionControlNetPipeline"),sl=p(),M=n("div"),u(Ho.$$.fragment),nu=p(),ji=n("p"),au=r("Pipeline for text-to-image generation using Stable Diffusion with ControlNet Guidance."),su=p(),Wo=n("p"),iu=r("This model inherits from "),Ni=n("code"),ru=r("FlaxDiffusionPipeline"),lu=r(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),pu=p(),ee=n("div"),u(Bo.$$.fragment),cu=p(),Di=n("p"),du=r("Function invoked when calling the pipeline for generation."),fu=p(),u(mt.$$.fragment),this.h()},l(t){const d=Tv('[data-svelte="svelte-1phssyn"]',document.head);w=a(d,"META",{name:!0,content:!0}),d.forEach(o),N=c(t),k=a(t,"H1",{class:!0});var Vo=s(k);y=a(Vo,"A",{id:!0,class:!0,href:!0});var Si=s(y);P=a(Si,"SPAN",{});var Ti=s(P);h(m.$$.fragment,Ti),Ti.forEach(o),Si.forEach(o),x=c(Vo),ya=a(Vo,"SPAN",{});var zu=s(ya);Zl=l(zu,"Text-to-Image Generation with ControlNet Conditioning"),zu.forEach(o),Vo.forEach(o),Ui=c(t),ne=a(t,"H2",{class:!0});var rl=s(ne);Ee=a(rl,"A",{id:!0,class:!0,href:!0});var Ru=s(Ee);wa=a(Ru,"SPAN",{});var Hu=s(wa);h(xt.$$.fragment,Hu),Hu.forEach(o),Ru.forEach(o),Ql=c(rl),$a=a(rl,"SPAN",{});var Wu=s($a);ep=l(Wu,"Overview"),Wu.forEach(o),rl.forEach(o),zi=c(t),Ct=a(t,"P",{});var mu=s(Ct);Pt=a(mu,"A",{href:!0,rel:!0});var Bu=s(Pt);tp=l(Bu,"Adding Conditional Control to Text-to-Image Diffusion Models"),Bu.forEach(o),op=l(mu," by Lvmin Zhang and Maneesh Agrawala."),mu.forEach(o),Ri=c(t),Ko=a(t,"P",{});var Vu=s(Ko);np=l(Vu,"Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),Vu.forEach(o),Hi=c(t),Yo=a(t,"P",{});var Ku=s(Yo);ap=l(Ku,"The abstract of the paper is the following:"),Ku.forEach(o),Wi=c(t),Jo=a(t,"P",{});var Yu=s(Jo);Ea=a(Yu,"EM",{});var Ju=s(Ea);sp=l(Ju,"We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),Ju.forEach(o),Yu.forEach(o),Bi=c(t),ke=a(t,"P",{});var ll=s(ke);ip=l(ll,"This model was contributed by the amazing community contributor "),jt=a(ll,"A",{href:!0,rel:!0});var Xu=s(jt);rp=l(Xu,"takuma104"),Xu.forEach(o),lp=l(ll," \u2764\uFE0F ."),ll.forEach(o),Vi=c(t),Xo=a(t,"P",{});var Zu=s(Xo);pp=l(Zu,"Resources:"),Zu.forEach(o),Ki=c(t),xe=a(t,"UL",{});var pl=s(xe);ka=a(pl,"LI",{});var Qu=s(ka);Nt=a(Qu,"A",{href:!0,rel:!0});var eh=s(Nt);cp=l(eh,"Paper"),eh.forEach(o),Qu.forEach(o),dp=c(pl),xa=a(pl,"LI",{});var th=s(xa);Dt=a(th,"A",{href:!0,rel:!0});var oh=s(Dt);fp=l(oh,"Original Code"),oh.forEach(o),th.forEach(o),pl.forEach(o),Yi=c(t),ae=a(t,"H2",{class:!0});var cl=s(ae);Ce=a(cl,"A",{id:!0,class:!0,href:!0});var nh=s(Ce);Ca=a(nh,"SPAN",{});var ah=s(Ca);h(St.$$.fragment,ah),ah.forEach(o),nh.forEach(o),mp=c(cl),Pa=a(cl,"SPAN",{});var sh=s(Pa);up=l(sh,"Available Pipelines:"),sh.forEach(o),cl.forEach(o),Ji=c(t),Pe=a(t,"TABLE",{});var dl=s(Pe);ja=a(dl,"THEAD",{});var ih=s(ja);se=a(ih,"TR",{});var pa=s(se);Na=a(pa,"TH",{});var rh=s(Na);hp=l(rh,"Pipeline"),rh.forEach(o),gp=c(pa),Da=a(pa,"TH",{});var lh=s(Da);_p=l(lh,"Tasks"),lh.forEach(o),vp=c(pa),Zo=a(pa,"TH",{align:!0});var ph=s(Zo);bp=l(ph,"Demo"),ph.forEach(o),pa.forEach(o),ih.forEach(o),yp=c(dl),Sa=a(dl,"TBODY",{});var ch=s(Sa);ie=a(ch,"TR",{});var ca=s(ie);Ta=a(ca,"TD",{});var dh=s(Ta);Tt=a(dh,"A",{href:!0,rel:!0});var fh=s(Tt);wp=l(fh,"StableDiffusionControlNetPipeline"),fh.forEach(o),dh.forEach(o),$p=c(ca),Aa=a(ca,"TD",{});var mh=s(Aa);Ia=a(mh,"EM",{});var uh=s(Ia);Ep=l(uh,"Text-to-Image Generation with ControlNet Conditioning"),uh.forEach(o),mh.forEach(o),kp=c(ca),Qo=a(ca,"TD",{align:!0});var hh=s(Qo);At=a(hh,"A",{href:!0,rel:!0});var gh=s(At);xp=l(gh,"Colab Example"),gh.forEach(o),hh.forEach(o),ca.forEach(o),ch.forEach(o),dl.forEach(o),Xi=c(t),re=a(t,"H2",{class:!0});var fl=s(re);je=a(fl,"A",{id:!0,class:!0,href:!0});var _h=s(je);Ma=a(_h,"SPAN",{});var vh=s(Ma);h(It.$$.fragment,vh),vh.forEach(o),_h.forEach(o),Cp=c(fl),qa=a(fl,"SPAN",{});var bh=s(qa);Pp=l(bh,"Usage example"),bh.forEach(o),fl.forEach(o),Zi=c(t),Ne=a(t,"P",{});var ml=s(Ne);jp=l(ml,"In the following we give a simple example of how to use a "),Fa=a(ml,"EM",{});var yh=s(Fa);Np=l(yh,"ControlNet"),yh.forEach(o),Dp=l(ml,` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),ml.forEach(o),Qi=c(t),De=a(t,"UL",{});var ul=s(De);La=a(ul,"LI",{});var wh=s(La);Ga=a(wh,"OL",{});var $h=s(Ga);Oa=a($h,"LI",{});var Eh=s(Oa);Sp=l(Eh,"Take an image and run it through a pre-conditioning processor."),Eh.forEach(o),$h.forEach(o),wh.forEach(o),Tp=c(ul),Ua=a(ul,"LI",{});var kh=s(Ua);en=a(kh,"OL",{start:!0});var xh=s(en);Mt=a(xh,"LI",{});var hl=s(Mt);Ap=l(hl,"Run the pre-processed image through the "),tn=a(hl,"A",{href:!0});var Ch=s(tn);Ip=l(Ch,"StableDiffusionControlNetPipeline"),Ch.forEach(o),Mp=l(hl,"."),hl.forEach(o),xh.forEach(o),kh.forEach(o),ul.forEach(o),er=c(t),Se=a(t,"P",{});var gl=s(Se);qp=l(gl,"Let\u2019s have a look at a simple example using the "),qt=a(gl,"A",{href:!0,rel:!0});var Ph=s(qt);Fp=l(Ph,"Canny Edge ControlNet"),Ph.forEach(o),Lp=l(gl,"."),gl.forEach(o),tr=c(t),h(Ft.$$.fragment,t),or=c(t),on=a(t,"P",{});var jh=s(on);nn=a(jh,"IMG",{src:!0,alt:!0}),jh.forEach(o),nr=c(t),V=a(t,"P",{});var da=s(V);Gp=l(da,"Next, we process the image to get the canny image. This is step "),za=a(da,"EM",{});var Nh=s(za);Op=l(Nh,"1."),Nh.forEach(o),Up=l(da," - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),an=a(da,"A",{href:!0});var Dh=s(an);zp=l(Dh,"official checkpoints"),Dh.forEach(o),Rp=l(da," for more information about other models."),da.forEach(o),ar=c(t),sn=a(t,"P",{});var Sh=s(sn);Hp=l(Sh,"First, we need to install opencv:"),Sh.forEach(o),sr=c(t),h(Lt.$$.fragment,t),ir=c(t),rn=a(t,"P",{});var Th=s(rn);Wp=l(Th,"Next, let\u2019s also install all required Hugging Face libraries:"),Th.forEach(o),rr=c(t),h(Gt.$$.fragment,t),lr=c(t),ln=a(t,"P",{});var Ah=s(ln);Bp=l(Ah,"Then we can retrieve the canny edges of the image."),Ah.forEach(o),pr=c(t),h(Ot.$$.fragment,t),cr=c(t),pn=a(t,"P",{});var Ih=s(pn);Vp=l(Ih,"Let\u2019s take a look at the processed image."),Ih.forEach(o),dr=c(t),cn=a(t,"P",{});var Mh=s(cn);dn=a(Mh,"IMG",{src:!0,alt:!0}),Mh.forEach(o),fr=c(t),Te=a(t,"P",{});var _l=s(Te);Kp=l(_l,"Now, we load the official "),fn=a(_l,"A",{href:!0});var qh=s(fn);Yp=l(qh,"Stable Diffusion 1.5 Model"),qh.forEach(o),Jp=l(_l," as well as the ControlNet for canny edges."),_l.forEach(o),mr=c(t),h(Ut.$$.fragment,t),ur=c(t),Ae=a(t,"P",{});var vl=s(Ae);Xp=l(vl,"To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),mn=a(vl,"A",{href:!0});var Fh=s(mn);Zp=l(Fh,"UniPCMultistepScheduler"),Fh.forEach(o),Qp=l(vl,"."),vl.forEach(o),hr=c(t),h(zt.$$.fragment,t),gr=c(t),un=a(t,"P",{});var Lh=s(un);ec=l(Lh,"Finally, we can run the pipeline:"),Lh.forEach(o),_r=c(t),h(Rt.$$.fragment,t),vr=c(t),hn=a(t,"P",{});var Gh=s(hn);tc=l(Gh,"This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),Gh.forEach(o),br=c(t),gn=a(t,"P",{});var Oh=s(gn);_n=a(Oh,"IMG",{src:!0,alt:!0}),Oh.forEach(o),yr=c(t),le=a(t,"P",{});var Ai=s(le);Ra=a(Ai,"STRONG",{});var Uh=s(Ra);oc=l(Uh,"Note"),Uh.forEach(o),nc=l(Ai,": To see how to run all other ControlNet checkpoints, please have a look at "),vn=a(Ai,"A",{href:!0});var zh=s(vn);ac=l(zh,"ControlNet with Stable Diffusion 1.5"),zh.forEach(o),sc=l(Ai,"."),Ai.forEach(o),wr=c(t),pe=a(t,"H2",{class:!0});var bl=s(pe);Ie=a(bl,"A",{id:!0,class:!0,href:!0});var Rh=s(Ie);Ha=a(Rh,"SPAN",{});var Hh=s(Ha);h(Ht.$$.fragment,Hh),Hh.forEach(o),Rh.forEach(o),ic=c(bl),Wa=a(bl,"SPAN",{});var Wh=s(Wa);rc=l(Wh,"Combining multiple conditionings"),Wh.forEach(o),bl.forEach(o),$r=c(t),Me=a(t,"P",{});var yl=s(Me);lc=l(yl,"Multiple ControlNet conditionings can be combined for a single image generation. Pass a list of ControlNets to the pipeline\u2019s constructor and a corresponding list of conditionings to "),Ba=a(yl,"CODE",{});var Bh=s(Ba);pc=l(Bh,"__call__"),Bh.forEach(o),cc=l(yl,"."),yl.forEach(o),Er=c(t),bn=a(t,"P",{});var Vh=s(bn);dc=l(Vh,"When combining conditionings, it is helpful to mask conditionings such that they do not overlap. In the example, we mask the middle of the canny map where the pose conditioning is located."),Vh.forEach(o),kr=c(t),qe=a(t,"P",{});var wl=s(qe);fc=l(wl,"It can also be helpful to vary the "),Va=a(wl,"CODE",{});var Kh=s(Va);mc=l(Kh,"controlnet_conditioning_scales"),Kh.forEach(o),uc=l(wl," to emphasize one conditioning over the other."),wl.forEach(o),xr=c(t),ce=a(t,"H3",{class:!0});var $l=s(ce);Fe=a($l,"A",{id:!0,class:!0,href:!0});var Yh=s(Fe);Ka=a(Yh,"SPAN",{});var Jh=s(Ka);h(Wt.$$.fragment,Jh),Jh.forEach(o),Yh.forEach(o),hc=c($l),Ya=a($l,"SPAN",{});var Xh=s(Ya);gc=l(Xh,"Canny conditioning"),Xh.forEach(o),$l.forEach(o),Cr=c(t),yn=a(t,"P",{});var Zh=s(yn);_c=l(Zh,"The original image:"),Zh.forEach(o),Pr=c(t),wn=a(t,"IMG",{src:!0}),jr=c(t),$n=a(t,"P",{});var Qh=s($n);vc=l(Qh,"Prepare the conditioning:"),Qh.forEach(o),Nr=c(t),h(Bt.$$.fragment,t),Dr=c(t),En=a(t,"IMG",{src:!0}),Sr=c(t),de=a(t,"H3",{class:!0});var El=s(de);Le=a(El,"A",{id:!0,class:!0,href:!0});var eg=s(Le);Ja=a(eg,"SPAN",{});var tg=s(Ja);h(Vt.$$.fragment,tg),tg.forEach(o),eg.forEach(o),bc=c(El),Xa=a(El,"SPAN",{});var og=s(Xa);yc=l(og,"Openpose conditioning"),og.forEach(o),El.forEach(o),Tr=c(t),kn=a(t,"P",{});var ng=s(kn);wc=l(ng,"The original image:"),ng.forEach(o),Ar=c(t),Kt=a(t,"IMG",{src:!0,width:!0}),Ir=c(t),xn=a(t,"P",{});var ag=s(xn);$c=l(ag,"Prepare the conditioning:"),ag.forEach(o),Mr=c(t),h(Yt.$$.fragment,t),qr=c(t),Jt=a(t,"IMG",{src:!0,width:!0}),Fr=c(t),fe=a(t,"H3",{class:!0});var kl=s(fe);Ge=a(kl,"A",{id:!0,class:!0,href:!0});var sg=s(Ge);Za=a(sg,"SPAN",{});var ig=s(Za);h(Xt.$$.fragment,ig),ig.forEach(o),sg.forEach(o),Ec=c(kl),Qa=a(kl,"SPAN",{});var rg=s(Qa);kc=l(rg,"Running ControlNet with multiple conditionings"),rg.forEach(o),kl.forEach(o),Lr=c(t),h(Zt.$$.fragment,t),Gr=c(t),Qt=a(t,"IMG",{src:!0,width:!0}),Or=c(t),me=a(t,"H3",{class:!0});var xl=s(me);Oe=a(xl,"A",{id:!0,class:!0,href:!0});var lg=s(Oe);es=a(lg,"SPAN",{});var pg=s(es);h(eo.$$.fragment,pg),pg.forEach(o),lg.forEach(o),xc=c(xl),ts=a(xl,"SPAN",{});var cg=s(ts);Cc=l(cg,"Guess Mode"),cg.forEach(o),xl.forEach(o),Ur=c(t),K=a(t,"P",{});var fa=s(K);Pc=l(fa,"Guess Mode is "),to=a(fa,"A",{href:!0,rel:!0});var dg=s(to);jc=l(dg,"a ControlNet feature that was implemented"),dg.forEach(o),Nc=l(fa," after the publication of "),oo=a(fa,"A",{href:!0,rel:!0});var fg=s(oo);Dc=l(fg,"the paper"),fg.forEach(o),Sc=l(fa,". The description states:"),fa.forEach(o),zr=c(t),Cn=a(t,"BLOCKQUOTE",{});var mg=s(Cn);os=a(mg,"P",{});var ug=s(os);Tc=l(ug,"In this mode, the ControlNet encoder will try best to recognize the content of the input control map, like depth map, edge map, scribbles, etc, even if you remove all prompts."),ug.forEach(o),mg.forEach(o),Rr=c(t),ue=a(t,"H4",{class:!0});var Cl=s(ue);Ue=a(Cl,"A",{id:!0,class:!0,href:!0});var hg=s(Ue);ns=a(hg,"SPAN",{});var gg=s(ns);h(no.$$.fragment,gg),gg.forEach(o),hg.forEach(o),Ac=c(Cl),as=a(Cl,"SPAN",{});var _g=s(as);Ic=l(_g,"The core implementation:"),_g.forEach(o),Cl.forEach(o),Hr=c(t),Y=a(t,"P",{});var ma=s(Y);Mc=l(ma,"It adjusts the scale of the output residuals from ControlNet by a fixed ratio depending on the block depth. The shallowest DownBlock corresponds to "),ss=a(ma,"CODE",{});var vg=s(ss);qc=l(vg,"0.1"),vg.forEach(o),Fc=l(ma,". As the blocks get deeper, the scale increases exponentially, and the scale for the output of the MidBlock becomes "),is=a(ma,"CODE",{});var bg=s(is);Lc=l(bg,"1.0"),bg.forEach(o),Gc=l(ma,"."),ma.forEach(o),Wr=c(t),ze=a(t,"P",{});var Pl=s(ze);Oc=l(Pl,"Since the core implementation is just this, "),rs=a(Pl,"STRONG",{});var yg=s(rs);Uc=l(yg,"it does not have any impact on prompt conditioning"),yg.forEach(o),zc=l(Pl,". While it is common to use it without specifying any prompts, it is also possible to provide prompts if desired."),Pl.forEach(o),Br=c(t),he=a(t,"H4",{class:!0});var jl=s(he);Re=a(jl,"A",{id:!0,class:!0,href:!0});var wg=s(Re);ls=a(wg,"SPAN",{});var $g=s(ls);h(ao.$$.fragment,$g),$g.forEach(o),wg.forEach(o),Rc=c(jl),ps=a(jl,"SPAN",{});var Eg=s(ps);Hc=l(Eg,"Usage:"),Eg.forEach(o),jl.forEach(o),Vr=c(t),q=a(t,"P",{});var ut=s(q);Wc=l(ut,"Just specify "),cs=a(ut,"CODE",{});var kg=s(cs);Bc=l(kg,"guess_mode=True"),kg.forEach(o),Vc=l(ut," in the pipe() function. A "),ds=a(ut,"CODE",{});var xg=s(ds);Kc=l(xg,"guidance_scale"),xg.forEach(o),Yc=l(ut," between 3.0 and 5.0 is "),so=a(ut,"A",{href:!0,rel:!0});var Cg=s(so);Jc=l(Cg,"recommended"),Cg.forEach(o),Xc=l(ut,"."),ut.forEach(o),Kr=c(t),h(io.$$.fragment,t),Yr=c(t),ge=a(t,"H4",{class:!0});var Nl=s(ge);He=a(Nl,"A",{id:!0,class:!0,href:!0});var Pg=s(He);fs=a(Pg,"SPAN",{});var jg=s(fs);h(ro.$$.fragment,jg),jg.forEach(o),Pg.forEach(o),Zc=c(Nl),ms=a(Nl,"SPAN",{});var Ng=s(ms);Qc=l(Ng,"Output image comparison:"),Ng.forEach(o),Nl.forEach(o),Jr=l(t,`

Canny Control Example
`),We=a(t,"TABLE",{});var Dl=s(We);us=a(Dl,"THEAD",{});var Dg=s(us);lo=a(Dg,"TR",{});var Sl=s(lo);hs=a(Sl,"TH",{});var Sg=s(hs);ed=l(Sg,"no guess_mode with prompt"),Sg.forEach(o),td=c(Sl),gs=a(Sl,"TH",{});var Tg=s(gs);od=l(Tg,"guess_mode without prompt"),Tg.forEach(o),Sl.forEach(o),Dg.forEach(o),nd=c(Dl),_s=a(Dl,"TBODY",{});var Ag=s(_s);po=a(Ag,"TR",{});var Tl=s(po);vs=a(Tl,"TD",{});var Ig=s(vs);Pn=a(Ig,"A",{href:!0});var Mg=s(Pn);jn=a(Mg,"IMG",{width:!0,src:!0}),Mg.forEach(o),Ig.forEach(o),ad=c(Tl),bs=a(Tl,"TD",{});var qg=s(bs);Nn=a(qg,"A",{href:!0});var Fg=s(Nn);Dn=a(Fg,"IMG",{width:!0,src:!0}),Fg.forEach(o),qg.forEach(o),Tl.forEach(o),Ag.forEach(o),Dl.forEach(o),Xr=c(t),_e=a(t,"H2",{class:!0});var Al=s(_e);Be=a(Al,"A",{id:!0,class:!0,href:!0});var Lg=s(Be);ys=a(Lg,"SPAN",{});var Gg=s(ys);h(co.$$.fragment,Gg),Gg.forEach(o),Lg.forEach(o),sd=c(Al),ws=a(Al,"SPAN",{});var Og=s(ws);id=l(Og,"Available checkpoints"),Og.forEach(o),Al.forEach(o),Zr=c(t),J=a(t,"P",{});var ua=s(J);rd=l(ua,"ControlNet requires a "),$s=a(ua,"EM",{});var Ug=s($s);ld=l(Ug,"control image"),Ug.forEach(o),pd=l(ua," in addition to the text-to-image "),Es=a(ua,"EM",{});var zg=s(Es);cd=l(zg,"prompt"),zg.forEach(o),dd=l(ua,`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),ua.forEach(o),Qr=c(t),Ve=a(t,"P",{});var Il=s(Ve);fd=l(Il,"All checkpoints can be found under the authors\u2019 namespace "),fo=a(Il,"A",{href:!0,rel:!0});var Rg=s(fo);md=l(Rg,"lllyasviel"),Rg.forEach(o),ud=l(Il,"."),Il.forEach(o),el=c(t),ve=a(t,"H3",{class:!0});var Ml=s(ve);Ke=a(Ml,"A",{id:!0,class:!0,href:!0});var Hg=s(Ke);ks=a(Hg,"SPAN",{});var Wg=s(ks);h(mo.$$.fragment,Wg),Wg.forEach(o),Hg.forEach(o),hd=c(Ml),xs=a(Ml,"SPAN",{});var Bg=s(xs);gd=l(Bg,"ControlNet with Stable Diffusion 1.5"),Bg.forEach(o),Ml.forEach(o),tl=c(t),Ye=a(t,"TABLE",{});var ql=s(Ye);Cs=a(ql,"THEAD",{});var Vg=s(Cs);L=a(Vg,"TR",{});var ht=s(L);Ps=a(ht,"TH",{});var Kg=s(Ps);_d=l(Kg,"Model Name"),Kg.forEach(o),vd=c(ht),js=a(ht,"TH",{});var Yg=s(js);bd=l(Yg,"Control Image Overview"),Yg.forEach(o),yd=c(ht),Ns=a(ht,"TH",{});var Jg=s(Ns);wd=l(Jg,"Control Image Example"),Jg.forEach(o),$d=c(ht),Ds=a(ht,"TH",{});var Xg=s(Ds);Ed=l(Xg,"Generated Image Example"),Xg.forEach(o),ht.forEach(o),Vg.forEach(o),kd=c(ql),j=a(ql,"TBODY",{});var D=s(j);G=a(D,"TR",{});var gt=s(G);Je=a(gt,"TD",{});var Ii=s(Je);uo=a(Ii,"A",{href:!0,rel:!0});var Zg=s(uo);xd=l(Zg,"lllyasviel/sd-controlnet-canny"),Zg.forEach(o),Cd=a(Ii,"BR",{}),Pd=c(Ii),Ss=a(Ii,"EM",{});var Qg=s(Ss);jd=l(Qg,"Trained with canny edge detection"),Qg.forEach(o),Ii.forEach(o),Nd=c(gt),Ts=a(gt,"TD",{});var e_=s(Ts);Dd=l(e_,"A monochrome image with white edges on a black background."),e_.forEach(o),Sd=c(gt),As=a(gt,"TD",{});var t_=s(As);Sn=a(t_,"A",{href:!0});var o_=s(Sn);Xe=a(o_,"IMG",{width:!0,style:!0,src:!0}),o_.forEach(o),t_.forEach(o),Td=c(gt),Is=a(gt,"TD",{});var n_=s(Is);Tn=a(n_,"A",{href:!0});var a_=s(Tn);An=a(a_,"IMG",{width:!0,src:!0}),a_.forEach(o),n_.forEach(o),gt.forEach(o),Ad=c(D),O=a(D,"TR",{});var _t=s(O);Ze=a(_t,"TD",{});var Mi=s(Ze);ho=a(Mi,"A",{href:!0,rel:!0});var s_=s(ho);Id=l(s_,"lllyasviel/sd-controlnet-depth"),s_.forEach(o),Md=a(Mi,"BR",{}),qd=c(Mi),Ms=a(Mi,"EM",{});var i_=s(Ms);Fd=l(i_,"Trained with Midas depth estimation"),i_.forEach(o),Mi.forEach(o),Ld=c(_t),qs=a(_t,"TD",{});var r_=s(qs);Gd=l(r_,"A grayscale image with black representing deep areas and white representing shallow areas."),r_.forEach(o),Od=c(_t),Fs=a(_t,"TD",{});var l_=s(Fs);In=a(l_,"A",{href:!0});var p_=s(In);Mn=a(p_,"IMG",{width:!0,src:!0}),p_.forEach(o),l_.forEach(o),Ud=c(_t),Ls=a(_t,"TD",{});var c_=s(Ls);qn=a(c_,"A",{href:!0});var d_=s(qn);Fn=a(d_,"IMG",{width:!0,src:!0}),d_.forEach(o),c_.forEach(o),_t.forEach(o),zd=c(D),U=a(D,"TR",{});var vt=s(U);Qe=a(vt,"TD",{});var qi=s(Qe);go=a(qi,"A",{href:!0,rel:!0});var f_=s(go);Rd=l(f_,"lllyasviel/sd-controlnet-hed"),f_.forEach(o),Hd=a(qi,"BR",{}),Wd=c(qi),Gs=a(qi,"EM",{});var m_=s(Gs);Bd=l(m_,"Trained with HED edge detection (soft edge)"),m_.forEach(o),qi.forEach(o),Vd=c(vt),Os=a(vt,"TD",{});var u_=s(Os);Kd=l(u_,"A monochrome image with white soft edges on a black background."),u_.forEach(o),Yd=c(vt),Us=a(vt,"TD",{});var h_=s(Us);Ln=a(h_,"A",{href:!0});var g_=s(Ln);Gn=a(g_,"IMG",{width:!0,src:!0}),g_.forEach(o),h_.forEach(o),Jd=c(vt),zs=a(vt,"TD",{});var __=s(zs);On=a(__,"A",{href:!0});var v_=s(On);Un=a(v_,"IMG",{width:!0,src:!0}),v_.forEach(o),__.forEach(o),vt.forEach(o),Xd=c(D),z=a(D,"TR",{});var bt=s(z);et=a(bt,"TD",{});var Fi=s(et);_o=a(Fi,"A",{href:!0,rel:!0});var b_=s(_o);Zd=l(b_,"lllyasviel/sd-controlnet-mlsd"),b_.forEach(o),Qd=a(Fi,"BR",{}),ef=c(Fi),Rs=a(Fi,"EM",{});var y_=s(Rs);tf=l(y_,"Trained with M-LSD line detection"),y_.forEach(o),Fi.forEach(o),of=c(bt),Hs=a(bt,"TD",{});var w_=s(Hs);nf=l(w_,"A monochrome image composed only of white straight lines on a black background."),w_.forEach(o),af=c(bt),Ws=a(bt,"TD",{});var $_=s(Ws);zn=a($_,"A",{href:!0});var E_=s(zn);Rn=a(E_,"IMG",{width:!0,src:!0}),E_.forEach(o),$_.forEach(o),sf=c(bt),Bs=a(bt,"TD",{});var k_=s(Bs);Hn=a(k_,"A",{href:!0});var x_=s(Hn);Wn=a(x_,"IMG",{width:!0,src:!0}),x_.forEach(o),k_.forEach(o),bt.forEach(o),rf=c(D),R=a(D,"TR",{});var yt=s(R);tt=a(yt,"TD",{});var Li=s(tt);vo=a(Li,"A",{href:!0,rel:!0});var C_=s(vo);lf=l(C_,"lllyasviel/sd-controlnet-normal"),C_.forEach(o),pf=a(Li,"BR",{}),cf=c(Li),Vs=a(Li,"EM",{});var P_=s(Vs);df=l(P_,"Trained with normal map"),P_.forEach(o),Li.forEach(o),ff=c(yt),bo=a(yt,"TD",{});var Fl=s(bo);mf=l(Fl,"A "),yo=a(Fl,"A",{href:!0,rel:!0});var j_=s(yo);uf=l(j_,"normal mapped"),j_.forEach(o),hf=l(Fl," image."),Fl.forEach(o),gf=c(yt),Ks=a(yt,"TD",{});var N_=s(Ks);Bn=a(N_,"A",{href:!0});var D_=s(Bn);Vn=a(D_,"IMG",{width:!0,src:!0}),D_.forEach(o),N_.forEach(o),_f=c(yt),Ys=a(yt,"TD",{});var S_=s(Ys);Kn=a(S_,"A",{href:!0});var T_=s(Kn);Yn=a(T_,"IMG",{width:!0,src:!0}),T_.forEach(o),S_.forEach(o),yt.forEach(o),vf=c(D),H=a(D,"TR",{});var wt=s(H);ot=a(wt,"TD",{});var Gi=s(ot);wo=a(Gi,"A",{href:!0,rel:!0});var A_=s(wo);bf=l(A_,"lllyasviel/sd-controlnet-openpose"),A_.forEach(o),yf=a(Gi,"BR",{}),wf=c(Gi),Js=a(Gi,"EM",{});var I_=s(Js);$f=l(I_,"Trained with OpenPose bone image"),I_.forEach(o),Gi.forEach(o),Ef=c(wt),$o=a(wt,"TD",{});var Ll=s($o);kf=l(Ll,"A "),Eo=a(Ll,"A",{href:!0,rel:!0});var M_=s(Eo);xf=l(M_,"OpenPose bone"),M_.forEach(o),Cf=l(Ll," image."),Ll.forEach(o),Pf=c(wt),Xs=a(wt,"TD",{});var q_=s(Xs);Jn=a(q_,"A",{href:!0});var F_=s(Jn);Xn=a(F_,"IMG",{width:!0,src:!0}),F_.forEach(o),q_.forEach(o),jf=c(wt),Zs=a(wt,"TD",{});var L_=s(Zs);Zn=a(L_,"A",{href:!0});var G_=s(Zn);Qn=a(G_,"IMG",{width:!0,src:!0}),G_.forEach(o),L_.forEach(o),wt.forEach(o),Nf=c(D),W=a(D,"TR",{});var $t=s(W);nt=a($t,"TD",{});var Oi=s(nt);ko=a(Oi,"A",{href:!0,rel:!0});var O_=s(ko);Df=l(O_,"lllyasviel/sd-controlnet-scribble"),O_.forEach(o),Sf=a(Oi,"BR",{}),Tf=c(Oi),Qs=a(Oi,"EM",{});var U_=s(Qs);Af=l(U_,"Trained with human scribbles"),U_.forEach(o),Oi.forEach(o),If=c($t),ei=a($t,"TD",{});var z_=s(ei);Mf=l(z_,"A hand-drawn monochrome image with white outlines on a black background."),z_.forEach(o),qf=c($t),ti=a($t,"TD",{});var R_=s(ti);ea=a(R_,"A",{href:!0});var H_=s(ea);ta=a(H_,"IMG",{width:!0,src:!0}),H_.forEach(o),R_.forEach(o),Ff=c($t),oi=a($t,"TD",{});var W_=s(oi);oa=a(W_,"A",{href:!0});var B_=s(oa);na=a(B_,"IMG",{width:!0,src:!0}),B_.forEach(o),W_.forEach(o),$t.forEach(o),Lf=c(D),B=a(D,"TR",{});var Et=s(B);xo=a(Et,"TD",{});var Gl=s(xo);Co=a(Gl,"A",{href:!0,rel:!0});var V_=s(Co);Gf=l(V_,"lllyasviel/sd-controlnet-seg"),V_.forEach(o),Of=a(Gl,"BR",{}),ni=a(Gl,"EM",{});var K_=s(ni);Uf=l(K_,"Trained with semantic segmentation"),K_.forEach(o),Gl.forEach(o),zf=c(Et),Po=a(Et,"TD",{});var Ol=s(Po);Rf=l(Ol,"An "),jo=a(Ol,"A",{href:!0,rel:!0});var Y_=s(jo);Hf=l(Y_,"ADE20K"),Y_.forEach(o),Wf=l(Ol,"\u2019s segmentation protocol image."),Ol.forEach(o),Bf=c(Et),ai=a(Et,"TD",{});var J_=s(ai);aa=a(J_,"A",{href:!0});var X_=s(aa);sa=a(X_,"IMG",{width:!0,src:!0}),X_.forEach(o),J_.forEach(o),Vf=c(Et),si=a(Et,"TD",{});var Z_=s(si);ia=a(Z_,"A",{href:!0});var Q_=s(ia);ra=a(Q_,"IMG",{width:!0,src:!0}),Q_.forEach(o),Z_.forEach(o),Et.forEach(o),D.forEach(o),ql.forEach(o),ol=c(t),be=a(t,"H2",{class:!0});var Ul=s(be);at=a(Ul,"A",{id:!0,class:!0,href:!0});var ev=s(at);ii=a(ev,"SPAN",{});var tv=s(ii);h(No.$$.fragment,tv),tv.forEach(o),ev.forEach(o),Kf=c(Ul),ri=a(Ul,"SPAN",{});var ov=s(ri);Yf=l(ov,"StableDiffusionControlNetPipeline"),ov.forEach(o),Ul.forEach(o),nl=c(t),$=a(t,"DIV",{class:!0});var C=s($);h(Do.$$.fragment,C),Jf=c(C),li=a(C,"P",{});var nv=s(li);Xf=l(nv,"Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),nv.forEach(o),Zf=c(C),So=a(C,"P",{});var zl=s(So);Qf=l(zl,"This model inherits from "),la=a(zl,"A",{href:!0});var av=s(la);em=l(av,"DiffusionPipeline"),av.forEach(o),tm=l(zl,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),zl.forEach(o),om=c(C),X=a(C,"DIV",{class:!0});var ha=s(X);h(To.$$.fragment,ha),nm=c(ha),pi=a(ha,"P",{});var sv=s(pi);am=l(sv,"Function invoked when calling the pipeline for generation."),sv.forEach(o),sm=c(ha),h(st.$$.fragment,ha),ha.forEach(o),im=c(C),Z=a(C,"DIV",{class:!0});var ga=s(Z);h(Ao.$$.fragment,ga),rm=c(ga),ci=a(ga,"P",{});var iv=s(ci);lm=l(iv,"Enable sliced attention computation."),iv.forEach(o),pm=c(ga),di=a(ga,"P",{});var rv=s(di);cm=l(rv,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),rv.forEach(o),ga.forEach(o),dm=c(C),it=a(C,"DIV",{class:!0});var Rl=s(it);h(Io.$$.fragment,Rl),fm=c(Rl),Mo=a(Rl,"P",{});var Hl=s(Mo);mm=l(Hl,"Disable sliced attention computation. If "),fi=a(Hl,"CODE",{});var lv=s(fi);um=l(lv,"enable_attention_slicing"),lv.forEach(o),hm=l(Hl,` was previously invoked, this method will go
back to computing attention in one step.`),Hl.forEach(o),Rl.forEach(o),gm=c(C),Q=a(C,"DIV",{class:!0});var _a=s(Q);h(qo.$$.fragment,_a),_m=c(_a),mi=a(_a,"P",{});var pv=s(mi);vm=l(pv,"Enable sliced VAE decoding."),pv.forEach(o),bm=c(_a),ui=a(_a,"P",{});var cv=s(ui);ym=l(cv,`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),cv.forEach(o),_a.forEach(o),wm=c(C),rt=a(C,"DIV",{class:!0});var Wl=s(rt);h(Fo.$$.fragment,Wl),$m=c(Wl),Lo=a(Wl,"P",{});var Bl=s(Lo);Em=l(Bl,"Disable sliced VAE decoding. If "),hi=a(Bl,"CODE",{});var dv=s(hi);km=l(dv,"enable_vae_slicing"),dv.forEach(o),xm=l(Bl,` was previously invoked, this method will go back to
computing decoding in one step.`),Bl.forEach(o),Wl.forEach(o),Cm=c(C),T=a(C,"DIV",{class:!0});var te=s(T);h(Go.$$.fragment,te),Pm=c(te),gi=a(te,"P",{});var fv=s(gi);jm=l(fv,"Enable memory efficient attention as implemented in xformers."),fv.forEach(o),Nm=c(te),_i=a(te,"P",{});var mv=s(_i);Dm=l(mv,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),mv.forEach(o),Sm=c(te),vi=a(te,"P",{});var uv=s(vi);Tm=l(uv,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),uv.forEach(o),Am=c(te),h(lt.$$.fragment,te),te.forEach(o),Im=c(C),pt=a(C,"DIV",{class:!0});var Vl=s(pt);h(Oo.$$.fragment,Vl),Mm=c(Vl),bi=a(Vl,"P",{});var hv=s(bi);qm=l(hv,"Disable memory efficient attention as implemented in xformers."),hv.forEach(o),Vl.forEach(o),Fm=c(C),ct=a(C,"DIV",{class:!0});var Kl=s(ct);h(Uo.$$.fragment,Kl),Lm=c(Kl),I=a(Kl,"P",{});var oe=s(I);Gm=l(oe,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),yi=a(oe,"CODE",{});var gv=s(yi);Om=l(gv,"enable_sequential_cpu_offload"),gv.forEach(o),Um=l(oe,", this method moves one whole model at a time to the GPU when its "),wi=a(oe,"CODE",{});var _v=s(wi);zm=l(_v,"forward"),_v.forEach(o),Rm=l(oe,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),$i=a(oe,"CODE",{});var vv=s($i);Hm=l(vv,"enable_sequential_cpu_offload"),vv.forEach(o),Wm=l(oe,", but performance is much better due to the iterative execution of the "),Ei=a(oe,"CODE",{});var bv=s(Ei);Bm=l(bv,"unet"),bv.forEach(o),Vm=l(oe,"."),oe.forEach(o),Kl.forEach(o),Km=c(C),dt=a(C,"DIV",{class:!0});var Yl=s(dt);h(zo.$$.fragment,Yl),Ym=c(Yl),ye=a(Yl,"P",{});var va=s(ye);Jm=l(va,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),ki=a(va,"CODE",{});var yv=s(ki);Xm=l(yv,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),yv.forEach(o),Zm=l(va,"forward"),xi=a(va,"CODE",{});var wv=s(xi);Qm=l(wv,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),wv.forEach(o),eu=l(va,"enable_model_cpu_offload`, but performance is lower."),va.forEach(o),Yl.forEach(o),C.forEach(o),al=c(t),we=a(t,"H2",{class:!0});var Jl=s(we);ft=a(Jl,"A",{id:!0,class:!0,href:!0});var $v=s(ft);Ci=a($v,"SPAN",{});var Ev=s(Ci);h(Ro.$$.fragment,Ev),Ev.forEach(o),$v.forEach(o),tu=c(Jl),Pi=a(Jl,"SPAN",{});var kv=s(Pi);ou=l(kv,"FlaxStableDiffusionControlNetPipeline"),kv.forEach(o),Jl.forEach(o),sl=c(t),M=a(t,"DIV",{class:!0});var kt=s(M);h(Ho.$$.fragment,kt),nu=c(kt),ji=a(kt,"P",{});var xv=s(ji);au=l(xv,"Pipeline for text-to-image generation using Stable Diffusion with ControlNet Guidance."),xv.forEach(o),su=c(kt),Wo=a(kt,"P",{});var Xl=s(Wo);iu=l(Xl,"This model inherits from "),Ni=a(Xl,"CODE",{});var Cv=s(Ni);ru=l(Cv,"FlaxDiffusionPipeline"),Cv.forEach(o),lu=l(Xl,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Xl.forEach(o),pu=c(kt),ee=a(kt,"DIV",{class:!0});var ba=s(ee);h(Bo.$$.fragment,ba),cu=c(ba),Di=a(ba,"P",{});var Pv=s(Di);du=l(Pv,"Function invoked when calling the pipeline for generation."),Pv.forEach(o),fu=c(ba),h(mt.$$.fragment,ba),ba.forEach(o),kt.forEach(o),this.h()},h(){i(w,"name","hf:doc:metadata"),i(w,"content",JSON.stringify(Lv)),i(y,"id","texttoimage-generation-with-controlnet-conditioning"),i(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(y,"href","#texttoimage-generation-with-controlnet-conditioning"),i(k,"class","relative group"),i(Ee,"id","overview"),i(Ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ee,"href","#overview"),i(ne,"class","relative group"),i(Pt,"href","https://arxiv.org/abs/2302.05543"),i(Pt,"rel","nofollow"),i(jt,"href","https://huggingface.co/takuma104"),i(jt,"rel","nofollow"),i(Nt,"href","https://arxiv.org/abs/2302.05543"),i(Nt,"rel","nofollow"),i(Dt,"href","https://github.com/lllyasviel/ControlNet"),i(Dt,"rel","nofollow"),i(Ce,"id","available-pipelines"),i(Ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ce,"href","#available-pipelines"),i(ae,"class","relative group"),i(Zo,"align","center"),i(Tt,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py"),i(Tt,"rel","nofollow"),i(At,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/controlnet.ipynb"),i(At,"rel","nofollow"),i(Qo,"align","center"),i(je,"id","usage-example"),i(je,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(je,"href","#usage-example"),i(re,"class","relative group"),i(tn,"href","/docs/diffusers/pr_3122/en/api/pipelines/stable_diffusion/controlnet#diffusers.StableDiffusionControlNetPipeline"),i(en,"start","2"),i(qt,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),i(qt,"rel","nofollow"),E(nn.src,gu="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png")||i(nn,"src",gu),i(nn,"alt","img"),i(an,"href","#controlnet-with-stable-diffusion-1.5"),E(dn.src,_u="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_canny_edged.png")||i(dn,"src",_u),i(dn,"alt","img"),i(fn,"href","runwayml/stable-diffusion-v1-5"),i(mn,"href","/docs/diffusers/pr_3122/en/api/schedulers/unipc#diffusers.UniPCMultistepScheduler"),E(_n.src,vu="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_disco_dancing.png")||i(_n,"src",vu),i(_n,"alt","img"),i(vn,"href","#controlnet-with-stable-diffusion-1.5"),i(Ie,"id","combining-multiple-conditionings"),i(Ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ie,"href","#combining-multiple-conditionings"),i(pe,"class","relative group"),i(Fe,"id","canny-conditioning"),i(Fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Fe,"href","#canny-conditioning"),i(ce,"class","relative group"),E(wn.src,bu="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png")||i(wn,"src",bu),E(En.src,yu="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/landscape_canny_masked.png")||i(En,"src",yu),i(Le,"id","openpose-conditioning"),i(Le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Le,"href","#openpose-conditioning"),i(de,"class","relative group"),E(Kt.src,wu="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png")||i(Kt,"src",wu),i(Kt,"width","600"),E(Jt.src,$u="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/person_pose.png")||i(Jt,"src",$u),i(Jt,"width","600"),i(Ge,"id","running-controlnet-with-multiple-conditionings"),i(Ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ge,"href","#running-controlnet-with-multiple-conditionings"),i(fe,"class","relative group"),E(Qt.src,Eu="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/multi_controlnet_output.png")||i(Qt,"src",Eu),i(Qt,"width","600"),i(Oe,"id","guess-mode"),i(Oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Oe,"href","#guess-mode"),i(me,"class","relative group"),i(to,"href","https://github.com/lllyasviel/ControlNet#guess-mode--non-prompt-mode"),i(to,"rel","nofollow"),i(oo,"href","https://arxiv.org/abs/2302.05543"),i(oo,"rel","nofollow"),i(Ue,"id","the-core-implementation"),i(Ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ue,"href","#the-core-implementation"),i(ue,"class","relative group"),i(Re,"id","usage"),i(Re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Re,"href","#usage"),i(he,"class","relative group"),i(so,"href","https://github.com/lllyasviel/ControlNet#guess-mode--non-prompt-mode"),i(so,"rel","nofollow"),i(He,"id","output-image-comparison"),i(He,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(He,"href","#output-image-comparison"),i(ge,"class","relative group"),i(jn,"width","128"),E(jn.src,ku="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare_guess_mode/output_images/diffusers/output_bird_canny_0.png")||i(jn,"src",ku),i(Pn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare_guess_mode/output_images/diffusers/output_bird_canny_0.png"),i(Dn,"width","128"),E(Dn.src,xu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare_guess_mode/output_images/diffusers/output_bird_canny_0_gm.png")||i(Dn,"src",xu),i(Nn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare_guess_mode/output_images/diffusers/output_bird_canny_0_gm.png"),i(Be,"id","available-checkpoints"),i(Be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Be,"href","#available-checkpoints"),i(_e,"class","relative group"),i(fo,"href","https://huggingface.co/lllyasviel"),i(fo,"rel","nofollow"),i(Ke,"id","controlnet-with-stable-diffusion-15"),i(Ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ke,"href","#controlnet-with-stable-diffusion-15"),i(ve,"class","relative group"),i(uo,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),i(uo,"rel","nofollow"),i(Xe,"width","64"),jv(Xe,"margin","0"),jv(Xe,"padding","0"),E(Xe.src,Cu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_canny.png")||i(Xe,"src",Cu),i(Sn,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_canny.png"),i(An,"width","64"),E(An.src,Pu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png")||i(An,"src",Pu),i(Tn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png"),i(ho,"href","https://huggingface.co/lllyasviel/sd-controlnet-depth"),i(ho,"rel","nofollow"),i(Mn,"width","64"),E(Mn.src,ju="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_depth.png")||i(Mn,"src",ju),i(In,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_depth.png"),i(Fn,"width","64"),E(Fn.src,Nu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png")||i(Fn,"src",Nu),i(qn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png"),i(go,"href","https://huggingface.co/lllyasviel/sd-controlnet-hed"),i(go,"rel","nofollow"),i(Gn,"width","64"),E(Gn.src,Du="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_hed.png")||i(Gn,"src",Du),i(Ln,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_hed.png"),i(Un,"width","64"),E(Un.src,Su="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png")||i(Un,"src",Su),i(On,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png"),i(_o,"href","https://huggingface.co/lllyasviel/sd-controlnet-mlsd"),i(_o,"rel","nofollow"),i(Rn,"width","64"),E(Rn.src,Tu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_mlsd.png")||i(Rn,"src",Tu),i(zn,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_mlsd.png"),i(Wn,"width","64"),E(Wn.src,Au="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png")||i(Wn,"src",Au),i(Hn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png"),i(vo,"href","https://huggingface.co/lllyasviel/sd-controlnet-normal"),i(vo,"rel","nofollow"),i(yo,"href","https://en.wikipedia.org/wiki/Normal_mapping"),i(yo,"rel","nofollow"),i(Vn,"width","64"),E(Vn.src,Iu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_normal.png")||i(Vn,"src",Iu),i(Bn,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_normal.png"),i(Yn,"width","64"),E(Yn.src,Mu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png")||i(Yn,"src",Mu),i(Kn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png"),i(wo,"href","https://huggingface.co/lllyasviel/sd-controlnet_openpose"),i(wo,"rel","nofollow"),i(Eo,"href","https://github.com/CMU-Perceptual-Computing-Lab/openpose"),i(Eo,"rel","nofollow"),i(Xn,"width","64"),E(Xn.src,qu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_openpose.png")||i(Xn,"src",qu),i(Jn,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_openpose.png"),i(Qn,"width","64"),E(Qn.src,Fu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png")||i(Qn,"src",Fu),i(Zn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png"),i(ko,"href","https://huggingface.co/lllyasviel/sd-controlnet_scribble"),i(ko,"rel","nofollow"),i(ta,"width","64"),E(ta.src,Lu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_scribble.png")||i(ta,"src",Lu),i(ea,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_scribble.png"),i(na,"width","64"),E(na.src,Gu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png")||i(na,"src",Gu),i(oa,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png"),i(Co,"href","https://huggingface.co/lllyasviel/sd-controlnet_seg"),i(Co,"rel","nofollow"),i(jo,"href","https://groups.csail.mit.edu/vision/datasets/ADE20K/"),i(jo,"rel","nofollow"),i(sa,"width","64"),E(sa.src,Ou="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_seg.png")||i(sa,"src",Ou),i(aa,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_seg.png"),i(ra,"width","64"),E(ra.src,Uu="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png")||i(ra,"src",Uu),i(ia,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png"),i(at,"id","diffusers.StableDiffusionControlNetPipeline"),i(at,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(at,"href","#diffusers.StableDiffusionControlNetPipeline"),i(be,"class","relative group"),i(la,"href","/docs/diffusers/pr_3122/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),i(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(it,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(pt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ft,"id","diffusers.FlaxStableDiffusionControlNetPipeline"),i(ft,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(ft,"href","#diffusers.FlaxStableDiffusionControlNetPipeline"),i(we,"class","relative group"),i(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,d){e(document.head,w),f(t,N,d),f(t,k,d),e(k,y),e(y,P),g(m,P,null),e(k,x),e(k,ya),e(ya,Zl),f(t,Ui,d),f(t,ne,d),e(ne,Ee),e(Ee,wa),g(xt,wa,null),e(ne,Ql),e(ne,$a),e($a,ep),f(t,zi,d),f(t,Ct,d),e(Ct,Pt),e(Pt,tp),e(Ct,op),f(t,Ri,d),f(t,Ko,d),e(Ko,np),f(t,Hi,d),f(t,Yo,d),e(Yo,ap),f(t,Wi,d),f(t,Jo,d),e(Jo,Ea),e(Ea,sp),f(t,Bi,d),f(t,ke,d),e(ke,ip),e(ke,jt),e(jt,rp),e(ke,lp),f(t,Vi,d),f(t,Xo,d),e(Xo,pp),f(t,Ki,d),f(t,xe,d),e(xe,ka),e(ka,Nt),e(Nt,cp),e(xe,dp),e(xe,xa),e(xa,Dt),e(Dt,fp),f(t,Yi,d),f(t,ae,d),e(ae,Ce),e(Ce,Ca),g(St,Ca,null),e(ae,mp),e(ae,Pa),e(Pa,up),f(t,Ji,d),f(t,Pe,d),e(Pe,ja),e(ja,se),e(se,Na),e(Na,hp),e(se,gp),e(se,Da),e(Da,_p),e(se,vp),e(se,Zo),e(Zo,bp),e(Pe,yp),e(Pe,Sa),e(Sa,ie),e(ie,Ta),e(Ta,Tt),e(Tt,wp),e(ie,$p),e(ie,Aa),e(Aa,Ia),e(Ia,Ep),e(ie,kp),e(ie,Qo),e(Qo,At),e(At,xp),f(t,Xi,d),f(t,re,d),e(re,je),e(je,Ma),g(It,Ma,null),e(re,Cp),e(re,qa),e(qa,Pp),f(t,Zi,d),f(t,Ne,d),e(Ne,jp),e(Ne,Fa),e(Fa,Np),e(Ne,Dp),f(t,Qi,d),f(t,De,d),e(De,La),e(La,Ga),e(Ga,Oa),e(Oa,Sp),e(De,Tp),e(De,Ua),e(Ua,en),e(en,Mt),e(Mt,Ap),e(Mt,tn),e(tn,Ip),e(Mt,Mp),f(t,er,d),f(t,Se,d),e(Se,qp),e(Se,qt),e(qt,Fp),e(Se,Lp),f(t,tr,d),g(Ft,t,d),f(t,or,d),f(t,on,d),e(on,nn),f(t,nr,d),f(t,V,d),e(V,Gp),e(V,za),e(za,Op),e(V,Up),e(V,an),e(an,zp),e(V,Rp),f(t,ar,d),f(t,sn,d),e(sn,Hp),f(t,sr,d),g(Lt,t,d),f(t,ir,d),f(t,rn,d),e(rn,Wp),f(t,rr,d),g(Gt,t,d),f(t,lr,d),f(t,ln,d),e(ln,Bp),f(t,pr,d),g(Ot,t,d),f(t,cr,d),f(t,pn,d),e(pn,Vp),f(t,dr,d),f(t,cn,d),e(cn,dn),f(t,fr,d),f(t,Te,d),e(Te,Kp),e(Te,fn),e(fn,Yp),e(Te,Jp),f(t,mr,d),g(Ut,t,d),f(t,ur,d),f(t,Ae,d),e(Ae,Xp),e(Ae,mn),e(mn,Zp),e(Ae,Qp),f(t,hr,d),g(zt,t,d),f(t,gr,d),f(t,un,d),e(un,ec),f(t,_r,d),g(Rt,t,d),f(t,vr,d),f(t,hn,d),e(hn,tc),f(t,br,d),f(t,gn,d),e(gn,_n),f(t,yr,d),f(t,le,d),e(le,Ra),e(Ra,oc),e(le,nc),e(le,vn),e(vn,ac),e(le,sc),f(t,wr,d),f(t,pe,d),e(pe,Ie),e(Ie,Ha),g(Ht,Ha,null),e(pe,ic),e(pe,Wa),e(Wa,rc),f(t,$r,d),f(t,Me,d),e(Me,lc),e(Me,Ba),e(Ba,pc),e(Me,cc),f(t,Er,d),f(t,bn,d),e(bn,dc),f(t,kr,d),f(t,qe,d),e(qe,fc),e(qe,Va),e(Va,mc),e(qe,uc),f(t,xr,d),f(t,ce,d),e(ce,Fe),e(Fe,Ka),g(Wt,Ka,null),e(ce,hc),e(ce,Ya),e(Ya,gc),f(t,Cr,d),f(t,yn,d),e(yn,_c),f(t,Pr,d),f(t,wn,d),f(t,jr,d),f(t,$n,d),e($n,vc),f(t,Nr,d),g(Bt,t,d),f(t,Dr,d),f(t,En,d),f(t,Sr,d),f(t,de,d),e(de,Le),e(Le,Ja),g(Vt,Ja,null),e(de,bc),e(de,Xa),e(Xa,yc),f(t,Tr,d),f(t,kn,d),e(kn,wc),f(t,Ar,d),f(t,Kt,d),f(t,Ir,d),f(t,xn,d),e(xn,$c),f(t,Mr,d),g(Yt,t,d),f(t,qr,d),f(t,Jt,d),f(t,Fr,d),f(t,fe,d),e(fe,Ge),e(Ge,Za),g(Xt,Za,null),e(fe,Ec),e(fe,Qa),e(Qa,kc),f(t,Lr,d),g(Zt,t,d),f(t,Gr,d),f(t,Qt,d),f(t,Or,d),f(t,me,d),e(me,Oe),e(Oe,es),g(eo,es,null),e(me,xc),e(me,ts),e(ts,Cc),f(t,Ur,d),f(t,K,d),e(K,Pc),e(K,to),e(to,jc),e(K,Nc),e(K,oo),e(oo,Dc),e(K,Sc),f(t,zr,d),f(t,Cn,d),e(Cn,os),e(os,Tc),f(t,Rr,d),f(t,ue,d),e(ue,Ue),e(Ue,ns),g(no,ns,null),e(ue,Ac),e(ue,as),e(as,Ic),f(t,Hr,d),f(t,Y,d),e(Y,Mc),e(Y,ss),e(ss,qc),e(Y,Fc),e(Y,is),e(is,Lc),e(Y,Gc),f(t,Wr,d),f(t,ze,d),e(ze,Oc),e(ze,rs),e(rs,Uc),e(ze,zc),f(t,Br,d),f(t,he,d),e(he,Re),e(Re,ls),g(ao,ls,null),e(he,Rc),e(he,ps),e(ps,Hc),f(t,Vr,d),f(t,q,d),e(q,Wc),e(q,cs),e(cs,Bc),e(q,Vc),e(q,ds),e(ds,Kc),e(q,Yc),e(q,so),e(so,Jc),e(q,Xc),f(t,Kr,d),g(io,t,d),f(t,Yr,d),f(t,ge,d),e(ge,He),e(He,fs),g(ro,fs,null),e(ge,Zc),e(ge,ms),e(ms,Qc),f(t,Jr,d),f(t,We,d),e(We,us),e(us,lo),e(lo,hs),e(hs,ed),e(lo,td),e(lo,gs),e(gs,od),e(We,nd),e(We,_s),e(_s,po),e(po,vs),e(vs,Pn),e(Pn,jn),e(po,ad),e(po,bs),e(bs,Nn),e(Nn,Dn),f(t,Xr,d),f(t,_e,d),e(_e,Be),e(Be,ys),g(co,ys,null),e(_e,sd),e(_e,ws),e(ws,id),f(t,Zr,d),f(t,J,d),e(J,rd),e(J,$s),e($s,ld),e(J,pd),e(J,Es),e(Es,cd),e(J,dd),f(t,Qr,d),f(t,Ve,d),e(Ve,fd),e(Ve,fo),e(fo,md),e(Ve,ud),f(t,el,d),f(t,ve,d),e(ve,Ke),e(Ke,ks),g(mo,ks,null),e(ve,hd),e(ve,xs),e(xs,gd),f(t,tl,d),f(t,Ye,d),e(Ye,Cs),e(Cs,L),e(L,Ps),e(Ps,_d),e(L,vd),e(L,js),e(js,bd),e(L,yd),e(L,Ns),e(Ns,wd),e(L,$d),e(L,Ds),e(Ds,Ed),e(Ye,kd),e(Ye,j),e(j,G),e(G,Je),e(Je,uo),e(uo,xd),e(Je,Cd),e(Je,Pd),e(Je,Ss),e(Ss,jd),e(G,Nd),e(G,Ts),e(Ts,Dd),e(G,Sd),e(G,As),e(As,Sn),e(Sn,Xe),e(G,Td),e(G,Is),e(Is,Tn),e(Tn,An),e(j,Ad),e(j,O),e(O,Ze),e(Ze,ho),e(ho,Id),e(Ze,Md),e(Ze,qd),e(Ze,Ms),e(Ms,Fd),e(O,Ld),e(O,qs),e(qs,Gd),e(O,Od),e(O,Fs),e(Fs,In),e(In,Mn),e(O,Ud),e(O,Ls),e(Ls,qn),e(qn,Fn),e(j,zd),e(j,U),e(U,Qe),e(Qe,go),e(go,Rd),e(Qe,Hd),e(Qe,Wd),e(Qe,Gs),e(Gs,Bd),e(U,Vd),e(U,Os),e(Os,Kd),e(U,Yd),e(U,Us),e(Us,Ln),e(Ln,Gn),e(U,Jd),e(U,zs),e(zs,On),e(On,Un),e(j,Xd),e(j,z),e(z,et),e(et,_o),e(_o,Zd),e(et,Qd),e(et,ef),e(et,Rs),e(Rs,tf),e(z,of),e(z,Hs),e(Hs,nf),e(z,af),e(z,Ws),e(Ws,zn),e(zn,Rn),e(z,sf),e(z,Bs),e(Bs,Hn),e(Hn,Wn),e(j,rf),e(j,R),e(R,tt),e(tt,vo),e(vo,lf),e(tt,pf),e(tt,cf),e(tt,Vs),e(Vs,df),e(R,ff),e(R,bo),e(bo,mf),e(bo,yo),e(yo,uf),e(bo,hf),e(R,gf),e(R,Ks),e(Ks,Bn),e(Bn,Vn),e(R,_f),e(R,Ys),e(Ys,Kn),e(Kn,Yn),e(j,vf),e(j,H),e(H,ot),e(ot,wo),e(wo,bf),e(ot,yf),e(ot,wf),e(ot,Js),e(Js,$f),e(H,Ef),e(H,$o),e($o,kf),e($o,Eo),e(Eo,xf),e($o,Cf),e(H,Pf),e(H,Xs),e(Xs,Jn),e(Jn,Xn),e(H,jf),e(H,Zs),e(Zs,Zn),e(Zn,Qn),e(j,Nf),e(j,W),e(W,nt),e(nt,ko),e(ko,Df),e(nt,Sf),e(nt,Tf),e(nt,Qs),e(Qs,Af),e(W,If),e(W,ei),e(ei,Mf),e(W,qf),e(W,ti),e(ti,ea),e(ea,ta),e(W,Ff),e(W,oi),e(oi,oa),e(oa,na),e(j,Lf),e(j,B),e(B,xo),e(xo,Co),e(Co,Gf),e(xo,Of),e(xo,ni),e(ni,Uf),e(B,zf),e(B,Po),e(Po,Rf),e(Po,jo),e(jo,Hf),e(Po,Wf),e(B,Bf),e(B,ai),e(ai,aa),e(aa,sa),e(B,Vf),e(B,si),e(si,ia),e(ia,ra),f(t,ol,d),f(t,be,d),e(be,at),e(at,ii),g(No,ii,null),e(be,Kf),e(be,ri),e(ri,Yf),f(t,nl,d),f(t,$,d),g(Do,$,null),e($,Jf),e($,li),e(li,Xf),e($,Zf),e($,So),e(So,Qf),e(So,la),e(la,em),e(So,tm),e($,om),e($,X),g(To,X,null),e(X,nm),e(X,pi),e(pi,am),e(X,sm),g(st,X,null),e($,im),e($,Z),g(Ao,Z,null),e(Z,rm),e(Z,ci),e(ci,lm),e(Z,pm),e(Z,di),e(di,cm),e($,dm),e($,it),g(Io,it,null),e(it,fm),e(it,Mo),e(Mo,mm),e(Mo,fi),e(fi,um),e(Mo,hm),e($,gm),e($,Q),g(qo,Q,null),e(Q,_m),e(Q,mi),e(mi,vm),e(Q,bm),e(Q,ui),e(ui,ym),e($,wm),e($,rt),g(Fo,rt,null),e(rt,$m),e(rt,Lo),e(Lo,Em),e(Lo,hi),e(hi,km),e(Lo,xm),e($,Cm),e($,T),g(Go,T,null),e(T,Pm),e(T,gi),e(gi,jm),e(T,Nm),e(T,_i),e(_i,Dm),e(T,Sm),e(T,vi),e(vi,Tm),e(T,Am),g(lt,T,null),e($,Im),e($,pt),g(Oo,pt,null),e(pt,Mm),e(pt,bi),e(bi,qm),e($,Fm),e($,ct),g(Uo,ct,null),e(ct,Lm),e(ct,I),e(I,Gm),e(I,yi),e(yi,Om),e(I,Um),e(I,wi),e(wi,zm),e(I,Rm),e(I,$i),e($i,Hm),e(I,Wm),e(I,Ei),e(Ei,Bm),e(I,Vm),e($,Km),e($,dt),g(zo,dt,null),e(dt,Ym),e(dt,ye),e(ye,Jm),e(ye,ki),e(ki,Xm),e(ye,Zm),e(ye,xi),e(xi,Qm),e(ye,eu),f(t,al,d),f(t,we,d),e(we,ft),e(ft,Ci),g(Ro,Ci,null),e(we,tu),e(we,Pi),e(Pi,ou),f(t,sl,d),f(t,M,d),g(Ho,M,null),e(M,nu),e(M,ji),e(ji,au),e(M,su),e(M,Wo),e(Wo,iu),e(Wo,Ni),e(Ni,ru),e(Wo,lu),e(M,pu),e(M,ee),g(Bo,ee,null),e(ee,cu),e(ee,Di),e(Di,du),e(ee,fu),g(mt,ee,null),il=!0},p(t,[d]){const Vo={};d&2&&(Vo.$$scope={dirty:d,ctx:t}),st.$set(Vo);const Si={};d&2&&(Si.$$scope={dirty:d,ctx:t}),lt.$set(Si);const Ti={};d&2&&(Ti.$$scope={dirty:d,ctx:t}),mt.$set(Ti)},i(t){il||(_(m.$$.fragment,t),_(xt.$$.fragment,t),_(St.$$.fragment,t),_(It.$$.fragment,t),_(Ft.$$.fragment,t),_(Lt.$$.fragment,t),_(Gt.$$.fragment,t),_(Ot.$$.fragment,t),_(Ut.$$.fragment,t),_(zt.$$.fragment,t),_(Rt.$$.fragment,t),_(Ht.$$.fragment,t),_(Wt.$$.fragment,t),_(Bt.$$.fragment,t),_(Vt.$$.fragment,t),_(Yt.$$.fragment,t),_(Xt.$$.fragment,t),_(Zt.$$.fragment,t),_(eo.$$.fragment,t),_(no.$$.fragment,t),_(ao.$$.fragment,t),_(io.$$.fragment,t),_(ro.$$.fragment,t),_(co.$$.fragment,t),_(mo.$$.fragment,t),_(No.$$.fragment,t),_(Do.$$.fragment,t),_(To.$$.fragment,t),_(st.$$.fragment,t),_(Ao.$$.fragment,t),_(Io.$$.fragment,t),_(qo.$$.fragment,t),_(Fo.$$.fragment,t),_(Go.$$.fragment,t),_(lt.$$.fragment,t),_(Oo.$$.fragment,t),_(Uo.$$.fragment,t),_(zo.$$.fragment,t),_(Ro.$$.fragment,t),_(Ho.$$.fragment,t),_(Bo.$$.fragment,t),_(mt.$$.fragment,t),il=!0)},o(t){v(m.$$.fragment,t),v(xt.$$.fragment,t),v(St.$$.fragment,t),v(It.$$.fragment,t),v(Ft.$$.fragment,t),v(Lt.$$.fragment,t),v(Gt.$$.fragment,t),v(Ot.$$.fragment,t),v(Ut.$$.fragment,t),v(zt.$$.fragment,t),v(Rt.$$.fragment,t),v(Ht.$$.fragment,t),v(Wt.$$.fragment,t),v(Bt.$$.fragment,t),v(Vt.$$.fragment,t),v(Yt.$$.fragment,t),v(Xt.$$.fragment,t),v(Zt.$$.fragment,t),v(eo.$$.fragment,t),v(no.$$.fragment,t),v(ao.$$.fragment,t),v(io.$$.fragment,t),v(ro.$$.fragment,t),v(co.$$.fragment,t),v(mo.$$.fragment,t),v(No.$$.fragment,t),v(Do.$$.fragment,t),v(To.$$.fragment,t),v(st.$$.fragment,t),v(Ao.$$.fragment,t),v(Io.$$.fragment,t),v(qo.$$.fragment,t),v(Fo.$$.fragment,t),v(Go.$$.fragment,t),v(lt.$$.fragment,t),v(Oo.$$.fragment,t),v(Uo.$$.fragment,t),v(zo.$$.fragment,t),v(Ro.$$.fragment,t),v(Ho.$$.fragment,t),v(Bo.$$.fragment,t),v(mt.$$.fragment,t),il=!1},d(t){o(w),t&&o(N),t&&o(k),b(m),t&&o(Ui),t&&o(ne),b(xt),t&&o(zi),t&&o(Ct),t&&o(Ri),t&&o(Ko),t&&o(Hi),t&&o(Yo),t&&o(Wi),t&&o(Jo),t&&o(Bi),t&&o(ke),t&&o(Vi),t&&o(Xo),t&&o(Ki),t&&o(xe),t&&o(Yi),t&&o(ae),b(St),t&&o(Ji),t&&o(Pe),t&&o(Xi),t&&o(re),b(It),t&&o(Zi),t&&o(Ne),t&&o(Qi),t&&o(De),t&&o(er),t&&o(Se),t&&o(tr),b(Ft,t),t&&o(or),t&&o(on),t&&o(nr),t&&o(V),t&&o(ar),t&&o(sn),t&&o(sr),b(Lt,t),t&&o(ir),t&&o(rn),t&&o(rr),b(Gt,t),t&&o(lr),t&&o(ln),t&&o(pr),b(Ot,t),t&&o(cr),t&&o(pn),t&&o(dr),t&&o(cn),t&&o(fr),t&&o(Te),t&&o(mr),b(Ut,t),t&&o(ur),t&&o(Ae),t&&o(hr),b(zt,t),t&&o(gr),t&&o(un),t&&o(_r),b(Rt,t),t&&o(vr),t&&o(hn),t&&o(br),t&&o(gn),t&&o(yr),t&&o(le),t&&o(wr),t&&o(pe),b(Ht),t&&o($r),t&&o(Me),t&&o(Er),t&&o(bn),t&&o(kr),t&&o(qe),t&&o(xr),t&&o(ce),b(Wt),t&&o(Cr),t&&o(yn),t&&o(Pr),t&&o(wn),t&&o(jr),t&&o($n),t&&o(Nr),b(Bt,t),t&&o(Dr),t&&o(En),t&&o(Sr),t&&o(de),b(Vt),t&&o(Tr),t&&o(kn),t&&o(Ar),t&&o(Kt),t&&o(Ir),t&&o(xn),t&&o(Mr),b(Yt,t),t&&o(qr),t&&o(Jt),t&&o(Fr),t&&o(fe),b(Xt),t&&o(Lr),b(Zt,t),t&&o(Gr),t&&o(Qt),t&&o(Or),t&&o(me),b(eo),t&&o(Ur),t&&o(K),t&&o(zr),t&&o(Cn),t&&o(Rr),t&&o(ue),b(no),t&&o(Hr),t&&o(Y),t&&o(Wr),t&&o(ze),t&&o(Br),t&&o(he),b(ao),t&&o(Vr),t&&o(q),t&&o(Kr),b(io,t),t&&o(Yr),t&&o(ge),b(ro),t&&o(Jr),t&&o(We),t&&o(Xr),t&&o(_e),b(co),t&&o(Zr),t&&o(J),t&&o(Qr),t&&o(Ve),t&&o(el),t&&o(ve),b(mo),t&&o(tl),t&&o(Ye),t&&o(ol),t&&o(be),b(No),t&&o(nl),t&&o($),b(Do),b(To),b(st),b(Ao),b(Io),b(qo),b(Fo),b(Go),b(lt),b(Oo),b(Uo),b(zo),t&&o(al),t&&o(we),b(Ro),t&&o(sl),t&&o(M),b(Ho),b(Bo),b(mt)}}}const Lv={local:"texttoimage-generation-with-controlnet-conditioning",sections:[{local:"overview",title:"Overview"},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",title:"Usage example"},{local:"combining-multiple-conditionings",sections:[{local:"canny-conditioning",title:"Canny conditioning"},{local:"openpose-conditioning",title:"Openpose conditioning"},{local:"running-controlnet-with-multiple-conditionings",title:"Running ControlNet with multiple conditionings"},{local:"guess-mode",sections:[{local:"the-core-implementation",title:"The core implementation:"},{local:"usage",title:"Usage:"},{local:"output-image-comparison",title:"Output image comparison:"}],title:"Guess Mode"}],title:"Combining multiple conditionings"},{local:"available-checkpoints",sections:[{local:"controlnet-with-stable-diffusion-15",title:"ControlNet with Stable Diffusion 1.5"}],title:"Available checkpoints"},{local:"diffusers.StableDiffusionControlNetPipeline",title:"StableDiffusionControlNetPipeline"},{local:"diffusers.FlaxStableDiffusionControlNetPipeline",title:"FlaxStableDiffusionControlNetPipeline"}],title:"Text-to-Image Generation with ControlNet Conditioning"};function Gv($e){return Av(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Wv extends Nv{constructor(w){super();Dv(this,w,Gv,Fv,Sv,{})}}export{Wv as default,Lv as metadata};
